/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
(function(){"use strict";if(!window.jQuery){throw new Error("SAPUI5 requires jQuery as a prerequisite (>= version 1.7)");}if(jQuery.sap){return;}if(sap.ui.Device.browser.edge){window.Promise=undefined;}if(!window.Promise){ES6Promise.polyfill();}var _=window;var a=[];function b(l,m){a.push({level:l,message:m});}var c;var f=/^[0-9]+(?:\.([0-9]+)(?:\.([0-9]+))?)?(.*)$/;function V(M,i,d,s){if(M instanceof V){return M;}if(!(this instanceof V)){return new V(M,i,d,s);}var m;if(typeof M==="string"){m=f.exec(M);}else if(jQuery.isArray(M)){m=M;}else{m=arguments;}m=m||[];function n(v){v=parseInt(v,10);return isNaN(v)?0:v;}M=n(m[0]);i=n(m[1]);d=n(m[2]);s=String(m[3]||"");this.toString=function(){return M+"."+i+"."+d+s;};this.getMajor=function(){return M;};this.getMinor=function(){return i;};this.getPatch=function(){return d;};this.getSuffix=function(){return s;};this.compareTo=function(){var o=V.apply(window,arguments);return M-o.getMajor()||i-o.getMinor()||d-o.getPatch()||((s<o.getSuffix())?-1:(s===o.getSuffix())?0:1);};}V.prototype.inRange=function(m,M){return this.compareTo(m)>=0&&this.compareTo(M)<0;};var J=V(jQuery.fn.jquery);if(!J.inRange("1.7.0","2.2.0")){b("error","SAPUI5 requires a jQuery version of 1.7 or higher, but lower than 2.2; current version is "+jQuery.fn.jquery);}if(!jQuery.browser){jQuery.browser=(function(d){var r=/(webkit)[ \/]([\w.]+)/,i=/(opera)(?:.*version)?[ \/]([\w.]+)/,j=/(msie) ([\w.]+)/,l=/(mozilla)(?:.*? rv:([\w.]+))?/,d=d.toLowerCase(),m=r.exec(d)||i.exec(d)||j.exec(d)||d.indexOf("compatible")<0&&l.exec(d)||[],n={};if(m[1]){n[m[1]]=true;n.version=m[2]||"0";if(n.webkit){n.safari=true;}}return n;}(window.navigator.userAgent));}if(!!sap.ui.Device.browser.internet_explorer){jQuery.support=jQuery.support||{};jQuery.support.cors=true;var g=V(jQuery.fn.jquery);if(window.ActiveXObject!==undefined&&g.getMajor()==1&&g.getMinor()>=11){var C=function(){try{return new window.XMLHttpRequest();}catch(e){}};var h=function(){try{return new window.ActiveXObject("Microsoft.XMLHTTP");}catch(e){}};jQuery.ajaxSettings=jQuery.ajaxSettings||{};jQuery.ajaxSettings.xhr=function(){return!this.isLocal?C():h();};}}var k=(function(){var T,U,r,d=/^(.*\/)?download\/configurator[\/\?]/,i=/^(.*\/)?(sap-ui-(core|custom|boot|merged)(-.*)?)\.js([?#]|$)/,j=/^(.*\/)?resources\//;jQuery("script[src]").each(function(){var s=this.getAttribute("src"),m;if((m=s.match(d))!==null){T=this;U=s;r=(m[1]||"")+"resources/";return false;}else if((m=s.match(i))!==null){T=this;U=s;r=m[1]||"";return false;}else if(this.id=='sap-ui-bootstrap'&&(m=s.match(j))){T=this;U=s;r=m[0];return false;}});return{tag:T,url:U,resourceRoot:r};})();(function(){if(/sap-bootstrap-debug=(true|x|X)/.test(location.search)){debugger;}var r;try{r=window.localStorage.getItem("sap-ui-reboot-URL");window.localStorage.removeItem("sap-ui-reboot-URL");}catch(e){}if(r&&r!=="undefined"){var U=confirm("WARNING!\n\nUI5 will be booted from the URL below.\nPress 'Cancel' unless you have configured this.\n\n"+r);if(U){var s=k.tag,d="<script src=\""+r+"\"";jQuery.each(s.attributes,function(i,o){if(o.nodeName.indexOf("data-sap-ui-")==0){d+=" "+o.nodeName+"=\""+o.nodeValue.replace(/"/g,"&quot;")+"\"";}});d+="></script>";s.parentNode.removeChild(s);jQuery("#sap-ui-bootstrap-cachebusted").remove();window["sap-ui-config"]&&window["sap-ui-config"].resourceRoots&&(window["sap-ui-config"].resourceRoots[""]=undefined);document.write(d);var R=new Error("This is not a real error. Aborting UI5 bootstrap and rebooting from: "+r);R.name="Restart";throw R;}}})();(function(){var d=/sap-ui-debug=(true|x|X)/.test(location.search),i=window["sap-ui-optimized"];try{d=d||(window.localStorage.getItem("sap-ui-debug")=="X");}catch(e){}window["sap-ui-debug"]=d;if(/-dbg\.js([?#]|$)/.test(k.url)){window["sap-ui-loaddbg"]=true;window["sap-ui-debug"]=true;}if(i&&d){var D=k.url.replace(/\/(?:sap-ui-cachebuster\/)?([^\/]+)\.js/,"/$1-dbg.js");window["sap-ui-optimized"]=false;window["sap-ui-loaddbg"]=true;document.write("<script type=\"text/javascript\" src=\""+D+"\"></script>");var r=new Error("Aborting UI5 bootstrap and restarting from: "+D);r.name="Restart";throw r;}})();var p=_["sap-ui-config"]=(function(){function n(o){jQuery.each(o,function(i,v){var m=i.toLowerCase();if(!o.hasOwnProperty(m)){o[m]=v;delete o[i];}});return o;}var s=k.tag,d=_["sap-ui-config"],j="sap-ui-config.json";if(typeof d==="string"){b("warning","Loading external bootstrap configuration from \""+d+"\". This is a design time feature and not for productive usage!");if(d!==j){b("warning","The external bootstrap configuration file should be named \""+j+"\"!");}jQuery.ajax({url:d,dataType:'json',async:false,success:function(D,T,i){d=D;},error:function(i,T,o){b("error","Loading externalized bootstrap configuration from \""+d+"\" failed! Reason: "+o+"!");d=undefined;}});}d=n(d||{});d.resourceroots=d.resourceroots||{};d.themeroots=d.themeroots||{};d.resourceroots['']=d.resourceroots['']||k.resourceRoot;d['xx-loadallmode']=/(^|\/)(sap-?ui5|[^\/]+-all).js([?#]|$)/.test(k.url);if(s){var l=s.getAttribute("data-sap-ui-config");if(l){try{jQuery.extend(d,n((new Function("return {"+l+"};"))()));}catch(e){b("error","failed to parse data-sap-ui-config attribute: "+(e.message||e));}}jQuery.each(s.attributes,function(i,o){var m=o.name.match(/^data-sap-ui-(.*)$/);if(m){m=m[1].toLowerCase();if(m==='resourceroots'){jQuery.extend(d[m],jQuery.parseJSON(o.value));}else if(m==='theme-roots'){jQuery.extend(d.themeroots,jQuery.parseJSON(o.value));}else if(m!=='config'){d[m]=o.value;}}});}return d;}());if(p.noconflict===true||p.noconflict==="true"||p.noconflict==="x"){jQuery.noConflict();}jQuery.sap={};jQuery.sap.Version=V;jQuery.sap.now=!(window.performance&&window.performance.now&&window.performance.timing)?Date.now:function(){return window.performance.timing.navigationStart+window.performance.now();};jQuery.sap.debug=function(d){if(!window.localStorage){return null;}function r(U){alert("Usage of debug sources is "+(U?"on":"off")+" now.\nFor the change to take effect, you need to reload the page.");}if(d===true){window.localStorage.setItem("sap-ui-debug","X");r(true);}else if(d===false){window.localStorage.removeItem("sap-ui-debug");r(false);}return window.localStorage.getItem("sap-ui-debug")=="X";};jQuery.sap.setReboot=function(r){var U;if(!window.localStorage){return null;}try{if(r){window.localStorage.setItem("sap-ui-reboot-URL",r);alert("Next time this app is launched (only once), it will load UI5 from:\n"+r+".\nPlease reload the application page now.");}else{window.localStorage.removeItem("sap-ui-reboot-URL");}U=window.localStorage.getItem("sap-ui-reboot-URL");}catch(e){jQuery.sap.log.warning("Could not access localStorage while setting reboot URL '"+r+"' (are cookies disabled?): "+e.message);}return U;};jQuery.sap.statistics=function(d){if(!window.localStorage){return null;}function i(U){alert("Usage of Gateway statistics "+(U?"on":"off")+" now.\nFor the change to take effect, you need to reload the page.");}if(d===true){window.localStorage.setItem("sap-ui-statistics","X");i(true);}else if(d===false){window.localStorage.removeItem("sap-ui-statistics");i(false);}return window.localStorage.getItem("sap-ui-statistics")=="X";};(function(){var d=0,j=1,W=2,n=3,D=4,T=5,s=(window.top==window)?"":"["+window.location.pathname.split('/').slice(-1)[0]+"] ",L=[],M={'':j},o=null;function r(i,w){return("000"+String(i)).slice(-w);}function B(i){return(!i||isNaN(M[i]))?M['']:M[i];}function G(){if(!o){o={listeners:[],onLogEntry:function(l){for(var i=0;i<o.listeners.length;i++){if(o.listeners[i].onLogEntry){o.listeners[i].onLogEntry(l);}}},attach:function(l,i){if(i){o.listeners.push(i);if(i.onAttachToLog){i.onAttachToLog(l);}}},detach:function(l,m){for(var i=0;i<o.listeners.length;i++){if(o.listeners[i]===m){if(m.onDetachFromLog){m.onDetachFromLog(l);}o.listeners.splice(i,1);return;}}}};}return o;}function H(l,m,i,v){if(l<=B(v)){var w=jQuery.sap.now(),O=new Date(w),Q=Math.floor((w-Math.floor(w))*1000),R={time:r(O.getHours(),2)+":"+r(O.getMinutes(),2)+":"+r(O.getSeconds(),2)+"."+r(O.getMilliseconds(),3)+r(Q,3),date:r(O.getFullYear(),4)+"-"+r(O.getMonth()+1,2)+"-"+r(O.getDate(),2),timestamp:w,level:l,message:String(m||""),details:String(i||""),component:String(v||"")};L.push(R);if(o){o.onLogEntry(R);}if(window.console){var U=R.date+" "+R.time+" "+s+R.message+" - "+R.details+" "+R.component;switch(l){case d:case j:console.error(U);break;case W:console.warn(U);break;case n:console.info?console.info(U):console.log(U);break;case D:console.debug?console.debug(U):console.log(U);break;case T:console.trace?console.trace(U):console.log(U);break;}}return R;}}function K(i){this.fatal=function(m,l,v){H(d,m,l,v||i);return this;};this.error=function error(m,l,v){H(j,m,l,v||i);return this;};this.warning=function warning(m,l,v){H(W,m,l,v||i);return this;};this.info=function info(m,l,v){H(n,m,l,v||i);return this;};this.debug=function debug(m,l,v){H(D,m,l,v||i);return this;};this.trace=function trace(m,l,v){H(T,m,l,v||i);return this;};this.setLevel=function setLevel(l,m){m=m||i||'';M[m]=l;var w=[];jQuery.each(jQuery.sap.log.LogLevel,function(O,v){w[v]=O;});H(n,"Changing log level "+(m?"for '"+m+"' ":"")+"to "+w[l],"","jQuery.sap.log");return this;};this.getLevel=function getLevel(l){return B(l||i);};this.isLoggable=function(l,m){return(l==null?D:l)<=B(m||i);};}jQuery.sap.log=jQuery.extend(new K(),{Level:{NONE:d-1,FATAL:d,ERROR:j,WARNING:W,INFO:n,DEBUG:D,TRACE:T,ALL:(T+1)},getLogger:function(i,l){if(!isNaN(l)&&M[i]==null){M[i]=l;}return new K(i);},getLogEntries:function(){return L.slice();},addLogListener:function(o){G().attach(this,o);return this;},removeLogListener:function(o){G().detach(this,o);return this;}});jQuery.sap.log.LogLevel=jQuery.sap.log.Level;jQuery.sap.log.getLog=jQuery.sap.log.getLogEntries;function N(){function m(i,l,f1,g1,h1){this.id=i;this.info=l;this.start=f1;this.end=g1;this.pause=0;this.resume=0;this.duration=0;this.time=0;this.categories=h1;this.average=false;this.count=0;this.completeDuration=0;}function v(l){if(!R){return true;}if(!l){return R===null;}for(var i=0;i<R.length;i++){if(l.indexOf(R[i])>-1){return true;}}return false;}function w(i){if(!i){i=["javascript"];}i=typeof i==="string"?i.split(","):i;if(!v(i)){return null;}return i;}var O=false,Q=jQuery.ajax,R=null,U=[],X=[],Y={},Z={};this.getActive=function(){return O;};this.setActive=function(i,l){if(!l){l=null;}else if(typeof l==="string"){l=l.split(",");}R=l;if(O===i){return;}O=i;if(O){for(var e1 in Y){this[e1]=Y[e1];}Y={};jQuery.ajax=function(f1,g1){if(typeof f1==='object'){g1=f1;f1=undefined;}g1=g1||{};var h1=new URI(f1||g1.url).absoluteTo(document.location.origin+document.location.pathname).href();jQuery.sap.measure.start(h1,"Request for "+h1,"xmlhttprequest");var i1=g1.complete;g1.complete=function(){jQuery.sap.measure.end(h1);if(i1){i1.apply(this,arguments);}};return Q.call(this,f1,g1);};}else if(Q){jQuery.ajax=Q;}return O;};Y["start"]=function(i,l,f1){if(!O){return;}f1=w(f1);if(!f1){return;}var g1=jQuery.sap.now(),h1=new m(i,l,g1,0,f1);if(jQuery.sap.log.getLevel("sap.ui.Performance")>=4&&window.console&&console.time){console.time(l+" - "+i);}if(h1){Z[i]=h1;return this.getMeasurement(h1.id);}else{return false;}};Y["pause"]=function(i){if(!O){return;}var l=jQuery.sap.now();var f1=Z[i];if(f1&&f1.end>0){return false;}if(f1&&f1.pause==0){f1.pause=l;if(f1.pause>=f1.resume&&f1.resume>0){f1.duration=f1.duration+f1.pause-f1.resume;f1.resume=0;}else if(f1.pause>=f1.start){f1.duration=f1.pause-f1.start;}}if(f1){return this.getMeasurement(f1.id);}else{return false;}};Y["resume"]=function(i){if(!O){return;}var l=jQuery.sap.now();var f1=Z[i];if(f1&&f1.pause>0){f1.pause=0;f1.resume=l;}if(f1){return this.getMeasurement(f1.id);}else{return false;}};Y["end"]=function(i){if(!O){return;}var l=jQuery.sap.now();var f1=Z[i];if(f1&&!f1.end){f1.end=l;if(f1.end>=f1.resume&&f1.resume>0){f1.duration=f1.duration+f1.end-f1.resume;f1.resume=0;}else if(f1.pause>0){f1.pause=0;}else if(f1.end>=f1.start){if(f1.average){f1.completeDuration+=(f1.end-f1.start);f1.count++;f1.duration=f1.completeDuration/f1.count;f1.start=l;}else{f1.duration=f1.end-f1.start;}}if(f1.end>=f1.start){f1.time=f1.end-f1.start;}}if(f1){if(jQuery.sap.log.getLevel("sap.ui.Performance")>=4&&window.console&&console.timeEnd){console.timeEnd(f1.info+" - "+i);}return this.getMeasurement(i);}else{return false;}};Y["clear"]=function(){Z={};};Y["remove"]=function(i){delete Z[i];};Y["add"]=function(i,l,f1,g1,h1,i1,j1){if(!O){return;}j1=w(j1);if(!j1){return false;}var k1=new m(i,l,f1,g1,j1);k1.time=h1;k1.duration=i1;if(k1){Z[i]=k1;return this.getMeasurement(k1.id);}else{return false;}};Y["average"]=function(i,l,f1){if(!O){return;}f1=w(f1);if(!f1){return;}var g1=Z[i],h1=jQuery.sap.now();if(!g1||!g1.average){this.start(i,l,f1);g1=Z[i];g1.average=true;}else{if(!g1.end){g1.completeDuration+=(h1-g1.start);g1.count++;}g1.start=h1;g1.end=0;}return this.getMeasurement(g1.id);};this.getMeasurement=function(i){var l=Z[i];if(l){return{id:l.id,info:l.info,start:l.start,end:l.end,pause:l.pause,resume:l.resume,time:l.time,duration:l.duration,completeDuration:l.completeDuration,count:l.count,average:l.average,categories:l.categories};}else{return false;}};this.getAllMeasurements=function(i){return this.filterMeasurements(function(l){return l;},i);};this.filterMeasurements=function(i,l){var f1=[],g1=this;jQuery.each(Z,function(h1){var i1=g1.getMeasurement(h1);if(i){var j1=i(i1);if(j1&&((l===false&&j1.end===0)||(l!==false&&(!l||j1.end)))){f1.push(j1);}}});return f1;};this.registerMethod=function(i,l,f1,g1){var h1=l[f1];if(h1&&typeof h1==="function"){var i1=U.indexOf(h1)>-1;if(!i1){X.push({func:h1,obj:l,method:f1,id:i});l[f1]=function(){jQuery.sap.measure.average(i,i+" method average",g1);var j1=h1.apply(this,arguments);jQuery.sap.measure.end(i);return j1;};U.push(l[f1]);return true;}}else{jQuery.sap.log.debug(f1+" in not a function. jQuery.sap.measure.register failed");}return false;};this.unregisterMethod=function(i,l,f1){var g1=l[f1],h1=U.indexOf(g1);if(g1&&h1>-1){l[f1]=X[h1].func;U.splice(h1,1);X.splice(h1,1);return true;}return false;};this.unregisterAllMethods=function(){while(X.length>0){var i=X[0];this.unregisterMethod(i.id,i.obj,i.method);}};var $=[];var a1;this.getAllInteractionMeasurements=function(i){if(i){jQuery.sap.measure.endInteraction(true);}return $;};this.filterInteractionMeasurements=function(f1){var g1=[];if(f1){for(var i=0,l=$.length;i<l;i++){if(f1($[i])){g1.push($[i]);}}}return g1;};this.getPendingInteractionMeasurement=function(){return a1;};this.clearInteractionMeasurements=function(){$=[];};function b1(i){if(a1){a1.end=i;a1.duration=a1.processing;a1.requests=jQuery.sap.measure.getRequestTimings();a1.measurements=jQuery.sap.measure.filterMeasurements(function(k1){return(k1.start>a1.start&&k1.end<a1.end)?k1:null;},true);if(a1.requests.length>0){var l=a1.requests[0].startTime,f1=a1.requests[0].startTime,g1=a1.requests[0].requestStart,h1=a1.requests[0].requestStart,i1=a1.requests[0].responseEnd;a1.requests.forEach(function(k1){l=k1.responseEnd>l?k1.responseEnd:l;a1.requestTime+=(k1.responseEnd-k1.startTime);if(i1<k1.startTime){a1.navigation+=(g1-f1);a1.roundtrip+=(i1-h1);f1=k1.startTime;h1=k1.requestStart;}if(k1.responseEnd>i1){g1=k1.requestStart;i1=k1.responseEnd;}});a1.navigation+=g1-f1;a1.roundtrip+=i1-h1;a1.networkTime=a1.networkTime?((a1.requestTime-a1.networkTime)/a1.requests.length):0;if(a1.duration===0){a1.duration=a1.navigation+a1.roundtrip;}}if(a1.processing!==0){var j1=a1.processing-a1.navigation-a1.roundtrip;a1.processing=j1>0?j1:0;}$.push(a1);jQuery.sap.log.info("Interaction step finished: trigger: "+a1.trigger+"; duration: "+a1.duration+"; requests: "+a1.requests.length,"jQuery.sap.measure");a1=null;}}this.startInteraction=function(i,l){function f1(l){var i1,j1;if(l){var k1,l1;k1=sap.ui.require("sap/ui/core/Component");while(k1&&l&&l.getParent){l1=k1.getOwnerComponentFor(l);if(l1||l instanceof k1){l1=l1||l;var m1=l1.getManifestEntry("sap.app");i1=m1&&m1.id||l1.getMetadata().getName();j1=m1&&m1.applicationVersion&&m1.applicationVersion.version;}l=l.getParent();}}return{id:i1?i1:"undetermined",version:j1?j1:""};}var g1=jQuery.sap.now();if(a1){b1(g1);}this.clearRequestTimings();var h1=f1(l);a1={event:i,trigger:l&&l.getId?l.getId():"undetermined",component:h1.id,appVersion:h1.version,start:g1,end:0,navigation:0,roundtrip:0,processing:0,duration:0,requests:[],measurements:[],sapStatistics:[],requestTime:0,networkTime:0,bytesSent:0,bytesReceived:0,requestCompression:undefined,busyDuration:0};jQuery.sap.log.info("Interaction step started: trigger: "+a1.trigger+"; type: "+a1.event,"jQuery.sap.measure");};this.endInteraction=function(i){if(a1){if(!i){a1.processing=jQuery.sap.now()-a1.start;}else{b1(jQuery.sap.now());}}};this.setRequestBufferSize=function(i){if(!window.performance){return;}if(window.performance.setResourceTimingBufferSize){window.performance.setResourceTimingBufferSize(i);}else if(window.performance.webkitSetResourceTimingBufferSize){window.performance.webkitSetResourceTimingBufferSize(i);}};this.getRequestTimings=function(){if(window.performance&&window.performance.getEntriesByType){return jQuery.extend(window.performance.getEntriesByType("resource"),{});}return[];};this.clearRequestTimings=function(){if(!window.performance){return;}if(window.performance.clearResourceTimings){window.performance.clearResourceTimings();}else if(window.performance.webkitClearResourceTimings){window.performance.webkitClearResourceTimings();}};this.setRequestBufferSize(1000);var c1=location.search.match(/sap-ui-measure=([^\&]*)/);if(c1&&c1[1]){if(c1[1]==="true"||c1[1]==="x"||c1[1]==="X"){this.setActive(true);}else{this.setActive(true,c1[1]);}}else{var d1=function(){return null;};for(var e1 in Y){this[e1]=d1;}}}jQuery.sap.measure=new N();jQuery.sap.assert=function(R,m){if(!R){var i=typeof m==="function"?m():m;if(window.console&&console.assert){console.assert(R,s+i);}else{jQuery.sap.log.debug("[Assertions] "+i);}}};p.loglevel=(function(){var m=/(?:\?|&)sap-ui-log(?:L|-l)evel=([^&]*)/.exec(window.location.search);return m&&m[1];}())||p.loglevel;if(p.loglevel){jQuery.sap.log.setLevel(jQuery.sap.log.Level[p.loglevel.toUpperCase()]||parseInt(p.loglevel,10));}jQuery.sap.log.info("SAP Logger started.");jQuery.each(a,function(i,e){jQuery.sap.log[e.level](e.message);});a=null;}());jQuery.sap.factory=function factory(o){function d(){}d.prototype=o;return d;};jQuery.sap.newObject=function newObject(o){return new(jQuery.sap.factory(o))();};jQuery.sap.getter=function getter(v){return function(){return v;};};jQuery.sap.getObject=function getObject(n,N,o){var O=o||_,d=(n||"").split("."),l=d.length,j=isNaN(N)?0:l-N,i;for(i=0;O&&i<l;i++){if(!O[d[i]]&&i<j){O[d[i]]={};}O=O[d[i]];}return O;};jQuery.sap.setObject=function(n,v,o){var O=o||_,N=(n||"").split("."),l=N.length,i;if(l>0){for(i=0;O&&i<l-1;i++){if(!O[N[i]]){O[N[i]]={};}O=O[N[i]];}O[N[l-1]]=v;}};function S(n,d,T){var i=[],o=0,j=0,s;this.startTask=function(m){var r=i.length;i[r]={name:m,finished:false};o++;return r;};this.finishTask=function(m,r){if(!i[m]||i[m].finished){throw new Error("trying to finish non existing or already finished task");}i[m].finished=true;o--;if(r===false){j++;}if(o===0){jQuery.sap.log.info("Sync point '"+n+"' finished (tasks:"+i.length+", open:"+o+", failures:"+j+")");if(s){clearTimeout(s);s=null;}l();}};function l(){d&&d(o,j);d=null;}if(!isNaN(T)){s=setTimeout(function(){jQuery.sap.log.info("Sync point '"+n+"' timed out (tasks:"+i.length+", open:"+o+", failures:"+j+")");l();},T);}jQuery.sap.log.info("Sync point '"+n+"' created"+(T?"(timeout after "+T+" ms)":""));}jQuery.sap.syncPoint=function(n,d,T){return new S(n,d,T);};var q=(function(){var o=jQuery.sap.log.getLogger("sap.ui.ModuleSystem",(/sap-ui-xx-debug(M|-m)odule(L|-l)oading=(true|x|X)/.test(location.search)||p["xx-debugModuleLoading"])?jQuery.sap.log.Level.DEBUG:jQuery.sap.log.Level.INFO),U={'':{'url':'resources/'}},r=0,v=-1,L=1,w=2,B=3,R=4,D=5,M={"sap/ui/thirdparty/URI.js":{state:R,url:c,content:URI},"sap/ui/Device.js":{state:R,url:c,content:sap.ui.Device},"jquery.sap.global.js":{state:R,url:c,content:jQuery}},G={},H={'sap/ui/thirdparty/blanket.js':{amd:true,exports:'blanket'},'sap/ui/thirdparty/caja-html-sanitizer.js':{amd:false,exports:'html'},'sap/ui/thirdparty/crossroads.js':{amd:true,exports:'crossroads',deps:['sap/ui/thirdparty/signals.js']},'sap/ui/thirdparty/d3.js':{amd:true,exports:'d3'},'sap/ui/thirdparty/datajs.js':{amd:true,exports:'OData'},'sap/ui/thirdparty/es6-promise.js':{amd:true,exports:'ES6Promise'},'sap/ui/thirdparty/flexie.js':{exports:'Flexie'},'sap/ui/thirdparty/handlebars.js':{amd:true,exports:'Handlebars'},'sap/ui/thirdparty/hasher.js':{amd:true,exports:'hasher',deps:['sap/ui/thirdparty/signals.js']},'sap/ui/thirdparty/IPv6.js':{amd:true,exports:'IPv6'},'sap/ui/thirdparty/iscroll-lite.js':{exports:'iScroll'},'sap/ui/thirdparty/iscroll.js':{exports:'iScroll'},'sap/ui/thirdparty/jquery.js':{amd:true},'sap/ui/thirdparty/jquery/jquery-1.11.1.js':{amd:true},'sap/ui/thirdparty/jquery/jquery-1.10.2.js':{amd:true},'sap/ui/thirdparty/jquery/jquery-1.10.1.js':{amd:true},'sap/ui/thirdparty/jquery/jquery.1.7.1.js':{amd:true},'sap/ui/thirdparty/jquery/jquery.1.8.1.js':{amd:true},'sap/ui/thirdparty/jquery-mobile-custom.js':{amd:true,exports:'jQuery.mobile'},'sap/ui/thirdparty/jszip.js':{amd:true,exports:'JSZip'},'sap/ui/thirdparty/less.js':{amd:true,exports:'less'},'sap/ui/thirdparty/mobify-carousel.js':{exports:'Mobify'},'sap/ui/thirdparty/punycode.js':{amd:true,exports:'punycode'},'sap/ui/thirdparty/require.js':{exports:'define'},'sap/ui/thirdparty/SecondLevelDomains.js':{amd:true,exports:'SecondLevelDomains'},'sap/ui/thirdparty/signals.js':{amd:true,exports:'signals'},'sap/ui/thirdparty/sinon.js':{amd:true,exports:'sinon'},'sap/ui/thirdparty/sinon-server.js':{amd:true,exports:'sinon'},'sap/ui/thirdparty/unorm.js':{exports:'UNorm'},'sap/ui/thirdparty/unormdata.js':{exports:'UNorm',deps:['sap/ui/thirdparty/unorm.js']},'sap/ui/thirdparty/URI.js':{amd:true,exports:'URI'},'sap/ui/thirdparty/URITemplate.js':{amd:true,exports:'URITemplate',deps:['sap/ui/thirdparty/URI.js']},'sap/ui/thirdparty/vkbeautify.js':{exports:'vkbeautify'},'sap/ui/thirdparty/zyngascroll.js':{exports:'Scroller'},'sap/ui/demokit/js/esprima.js':{amd:true,exports:'esprima'}},K=[],N="",O=512*1024,Q=document.location.href.replace(/\?.*|#.*/g,""),T="fragment",W="view",X={js:[W,T,"controller","designtime"],xml:[W,T],json:[W,T],html:[W,T]},Y=new RegExp("(\\.(?:"+X.js.join("|")+"))?\\.js$"),Z,$;(function(){var s="",d="";jQuery.each(X,function(i,j){s=(s?s+"|":"")+i;d=(d?d+"|":"")+"(?:(?:"+j.join("\\.|")+"\\.)?"+i+")";});s="\\.("+s+")$";d="\\.(?:"+d+"|[^./]+)$";o.debug("constructed regexp for file types :"+s);o.debug("constructed regexp for file sub-types :"+d);Z=new RegExp(s);$=new RegExp(d);}());function a1(s){if(/^sap\.ui\.thirdparty\.jquery\.jquery-/.test(s)){return"sap/ui/thirdparty/jquery/jquery-"+s.slice("sap.ui.thirdparty.jquery.jquery-".length);}else if(/^jquery\.sap\./.test(s)){return s;}return s.replace(/\./g,"/");}function b1(s){if(!/\.js$/.test(s)){return;}s=s.slice(0,-3);if(/^sap\/ui\/thirdparty\/jquery\/jquery-/.test(s)){return"sap.ui.thirdparty.jquery.jquery-"+s.slice("sap/ui/thirdparty/jquery/jquery-".length);}else if(/^jquery\.sap\./.test(s)){return s;}return s.replace(/\//g,".");}function c1(s,d){var i=s.split(/\//),l,j,n1,m;if(arguments.length===1&&i.length>0){m=$.exec(i[i.length-1]);if(m){d=m[0];i[i.length-1]=i[i.length-1].slice(0,m.index);}else{d="";}}for(l=i.length;l>=0;l--){j=i.slice(0,l).join('/');if(U[j]){n1=U[j].url;if(l<i.length){n1+=i.slice(l).join('/');}if(n1.slice(-1)==='/'){n1=n1.slice(0,-1);}return n1+(d||'');}}}function d1(s){var d,i,j;for(d in U){if(U.hasOwnProperty(d)){i=U[d].url.slice(0,-1);if(s.indexOf(i)===0){j=d+s.slice(i.length);if(j.charAt(0)==='/'){j=j.slice(1);}if(M[j]&&M[j].data){return j;}}}}}function e1(d){if(!d.stack){try{throw d;}catch(i){return i.stack;}}return d.stack;}function f1(d,i){if(!sap.ui.Device.browser.phantomJS){var j=e1(d);if(j&&i){d.stack=j+"\nCaused by: "+i;}}if(window.console&&!sap.ui.Device.browser.chrome){console.error(d.message+"\nCaused by: "+i);}}var g1=/(?:^|\/)\.+/;var h1=/^\.*$/;function i1(s,d){var m=g1.exec(d),n1,o1,i,j,l;if(!m){return d;}if(m.index===0&&s==null){throw new Error("relative name not supported ('"+d+"'");}n1=(m.index===0?s+d:d).split('/');for(i=0,j=0,l=n1.length;i<l;i++){var o1=n1[i];if(h1.test(o1)){if(o1==='.'||o1===''){continue;}else if(o1==='..'){if(j===0){throw new Error("Can't navigate to parent of root (base='"+s+"', name='"+d+"'");}j--;}else{throw new Error("illegal path segment '"+o1+"'");}}else{n1[j++]=o1;}}n1.length=j;return n1.join('/');}function j1(m){var d;d=M[m]||(M[m]={state:r});if(d.state>r){return d;}if(o.isLoggable()){o.debug(N+"declare module '"+m+"'");}d.state=R;if(K.length===0){K.push(m);d.url=d.url||c;}return d;}function k1(s){var m=Y.exec(s),d=H[s],j,l,n1,o1,i;if(!m){o.error("can only require Javascript module, not "+s);return;}if(d&&d.deps){if(o.isLoggable()){o.debug("require dependencies of raw module "+s);}for(i=0;i<d.deps.length;i++){if(o.isLoggable()){o.debug("  require "+d.deps[i]);}k1(d.deps[i]);}}j=s.slice(0,m.index);l=m[0];n1=M[s]||(M[s]={state:r});if(o.isLoggable()){o.debug(N+"require '"+s+"' of type '"+l+"'");}if(n1.state!==r){if(n1.state===v){n1.state=w;l1(s);}if(n1.state===R){if(o.isLoggable()){o.debug(N+"module '"+s+"' has already been loaded (skipped).");}return this;}else if(n1.state===D){var p1=new Error("found in negative cache: '"+s+"' from "+n1.url+": "+n1.errorMessage);f1(p1,n1.errorStack);throw p1;}else{return this;}}n1.state=L;o1=window["sap-ui-loaddbg"]?["-dbg",""]:[""];for(i=0;i<o1.length&&n1.state!==w;i++){n1.url=c1(j,o1[i]+l);if(o.isLoggable()){o.debug(N+"loading "+(o1[i]?o1[i]+" version of ":"")+"'"+s+"' from '"+n1.url+"'");}jQuery.ajax({url:n1.url,dataType:'text',async:false,success:function(q1,r1,s1){n1.state=w;n1.data=q1;},error:function(q1,r1,s1){n1.state=D;n1.errorMessage=q1?q1.status+" - "+q1.statusText:r1;n1.errorStack=s1&&s1.stack;}});}if(n1.state===w){l1(s);}if(n1.state!==R){var p1=new Error("failed to load '"+s+"' from "+n1.url+": "+n1.errorMessage);f1(p1,n1.errorStack);throw p1;}}function l1(m){var d=M[m],s=H[m],i,j,l;if(d&&d.state===w&&typeof d.data!=="undefined"){l=(s===true||(s&&s.amd))&&typeof window.define==="function"&&window.define.amd;try{if(l){delete window.define.amd;}if(o.isLoggable()){o.debug(N+"executing '"+m+"'");i=N;N=N+": ";}d.state=B;K.push(m);if(typeof d.data==="function"){d.data.call(window);}else if(jQuery.isArray(d.data)){sap.ui.define.apply(sap.ui,d.data);}else{j=d.data;if(j&&!j.match(/\/\/[#@] source(Mapping)?URL=.*$/)){j+="\n//# sourceURL="+URI(d.url).absoluteTo(Q);if(sap.ui.Device.browser.safari){j+="?";}}if(typeof jQuery.sap.require._hook==="function"){j=jQuery.sap.require._hook(j,m);}if(_.execScript&&(!d.data||d.data.length<O)){try{d.data&&_.execScript(j);}catch(e){K.pop();jQuery.sap.globalEval(d.data);throw e;}}else{_.eval(j);}}K.pop();d.state=R;d.data=undefined;d.content=d.content||jQuery.sap.getObject((s&&s.exports)||b1(m));if(o.isLoggable()){N=i;o.debug(N+"finished executing '"+m+"'");}}catch(n1){d.state=D;d.errorStack=n1&&n1.stack;d.errorMessage=((n1.toString&&n1.toString())||n1.message)+(n1.line?"(line "+n1.line+")":"");d.data=undefined;if(window["sap-ui-debug"]&&(/sap-ui-xx-show(L|-l)oad(E|-e)rrors=(true|x|X)/.test(location.search)||p["xx-showloaderrors"])){o.error("error while evaluating "+m+", embedding again via script tag to enforce a stack trace (see below)");jQuery.sap.includeScript(d.url);return;}}finally{if(l){window.define.amd=l;}}}}function m1(s,d,j){var m=[],i,l;for(i=0;i<d.length;i++){l=i1(s,d[i]);o.debug(N+"require '"+l+"'");k1(l+".js");m[i]=M[l+".js"].content||jQuery.sap.getObject(b1(l+".js"));o.debug(N+"require '"+l+"': done.");}j(m);}jQuery.sap.getModulePath=function(m,s){return c1(a1(m),s);};jQuery.sap.getResourcePath=c1;jQuery.sap.registerModulePath=function registerModulePath(m,d){m=m.replace(/\./g,"/");d=d||'.';jQuery.sap.registerResourcePath(m,d);};jQuery.sap.registerResourcePath=function registerResourcePath(s,d){s=String(s||"");if(U[s]&&U[s]["final"]==true){o.warning("registerResourcePath with prefix "+s+" already set as final to '"+U[s].url+"'. This call is ignored.");return;}if(typeof d==='string'||d instanceof String){d={'url':d};}if(!d||d.url==null){delete U[s];o.info("registerResourcePath ('"+s+"') (registration removed)");}else{d.url=String(d.url);var i=d.url.search(/[?#]/);if(i!==-1){d.url=d.url.slice(0,i);}if(d.url.slice(-1)!='/'){d.url+='/';}U[s]=d;o.info("registerResourcePath ('"+s+"', '"+d.url+"')"+((d['final'])?" (final)":""));}};jQuery.sap.isDeclared=function isDeclared(m,i){m=a1(m)+".js";return M[m]&&(i||M[m].state!==v);};jQuery.sap.getAllDeclaredModules=function(){var m=[];jQuery.each(M,function(s,d){if(d&&d.state!==v){var i=b1(s);if(i){m.push(i);}}});return m;};if(p.resourceroots){jQuery.each(p.resourceroots,jQuery.sap.registerModulePath);}o.info("URL prefixes set to:");for(var n in U){o.info("  "+(n?"'"+n+"'":"(default)")+" : "+U[n].url+((U[n]['final'])?" (final)":""));}jQuery.sap.declare=function(m,d){var s=m;if(typeof(m)==="object"){s=m.modName;m=a1(m.modName)+(m.type?"."+m.type:"")+".js";}else{m=a1(m)+".js";}j1(m);if(d!==false){jQuery.sap.getObject(s,1);}return this;};jQuery.sap.require=function(m,d){if(arguments.length>1){for(var i=0;i<arguments.length;i++){jQuery.sap.require(arguments[i]);}return this;}if(typeof(m)==="object"){m=a1(m.modName)+(m.type?"."+m.type:"")+".js";}else{m=a1(m)+".js";}jQuery.sap.measure.start(m,"Require module "+m,["require"]);k1(m);jQuery.sap.measure.end(m);return this;};jQuery.sap._requirePath=function(m){k1(m+".js");};window.sap=window.sap||{};sap.ui=sap.ui||{};sap.ui.define=function(m,d,i,j){var s,l;if(typeof m==='string'){s=m+'.js';}else{j=i;i=d;d=m;s=K[K.length-1];}m=b1(s);l=s.slice(0,s.lastIndexOf('/')+1);if(!jQuery.isArray(d)){j=i;i=d;d=[];}if(o.isLoggable()){o.debug("define("+s+", "+"['"+d.join("','")+"']"+")");}var n1=j1(s);m1(l,d,function(o1){if(o.isLoggable()){o.debug("define("+s+"): calling factory "+typeof i);}if(j){var p1=s.split('/').slice(0,-1).join('.');if(p1){jQuery.sap.getObject(p1,0);}}if(typeof i==='function'){n1.content=i.apply(window,o1);}else{n1.content=i;}if(j){if(n1.content==null){o.error("module '"+s+"' returned no content, but should be exported");}else{if(o.isLoggable()){o.debug("exporting content of '"+s+"': as global object");}jQuery.sap.setObject(m,n1.content);}}});};sap.ui.predefine=function(m,d,i,j){if(typeof m!=='string'){throw new Error("sap.ui.predefine requires a module name");}var s=m+'.js';var l=M[s];if(!l){M[s]={state:v,url:"TODO???/"+m,data:[m,d,i,j],group:null};}if(s.match(/\/library\.js$/)){G[b1(s)+"-preload"]=true;}};sap.ui.require=function(d,i){if(typeof d==='string'){var m=d+'.js',j=M[m];return j?(j.content||jQuery.sap.getObject(b1(m))):undefined;}m1(null,d,function(l){if(typeof i==='function'){setTimeout(function(){i.apply(window,l);},0);}});};jQuery.sap.preloadModules=function(s,d,i){var j,l;if(G[s]){return;}G[s]=true;j=jQuery.sap.getModulePath(s,".json");o.debug("preload file "+s);l=i&&i.startTask("load "+s);jQuery.ajax({dataType:"json",async:d,url:j,success:function(m){if(m){m.url=j;}jQuery.sap.registerPreloadedModules(m,d,i);i&&i.finishTask(l);},error:function(m,n1,o1){o.error("failed to preload '"+s+"': "+(o1||n1));i&&i.finishTask(l,false);}});};jQuery.sap.registerPreloadedModules=function(d,i,s){var j=V(d.version||"1.0").compareTo("2.0")<0;if(o.isLoggable()){o.debug(N+"adding preloaded modules from '"+d.url+"'");}if(d.name){G[d.name]=true;}jQuery.each(d.modules,function(l,m){l=j?a1(l)+".js":l;if(!M[l]){M[l]={state:v,url:d.url+"/"+l,data:m,group:d.name};}if(l.match(/\/library\.js$/)){G[b1(l)+"-preload"]=true;}});if(d.dependencies){jQuery.each(d.dependencies,function(l,m){jQuery.sap.preloadModules(m,i,s);});}};jQuery.sap.unloadResources=function(s,d,j,l){var m=[];if(d==null){d=true;}if(d){jQuery.each(M,function(i,n1){if(n1&&n1.group===s){m.push(i);}});delete G[s];}else{if(M[s]){m.push(s);}}jQuery.each(m,function(i,n1){var o1=M[n1];if(o1&&l&&n1.match(/\.js$/)){jQuery.sap.setObject(b1(n1),undefined);}if(o1&&(j||o1.state===v)){delete M[n1];}});};jQuery.sap.getResourceName=function(m,s){return a1(m)+(s||".js");};jQuery.sap.loadResource=function(s,m){var i,j,l,n1,o1;if(typeof s==="string"){m=m||{};}else{m=s||{};s=m.name;if(!s&&m.url){s=d1(m.url);}}m=jQuery.extend({failOnError:true,async:false},m);i=m.dataType;if(i==null&&s){i=(i=Z.exec(s))&&i[1];}o1=m.async?new jQuery.Deferred():null;function p1(d,e){if(d==null&&m.failOnError){n1=e||new Error("no data returned for "+s);if(m.async){o1.reject(n1);jQuery.sap.log.error(n1);}return null;}if(m.async){o1.resolve(d);}return d;}function q1(d){var r1=jQuery.ajaxSettings.converters["text "+i];if(typeof r1==="function"){d=r1(d);}return p1(d);}if(s&&M[s]){j=M[s].data;M[s].state=w;}if(j!=null){if(m.async){setTimeout(function(){q1(j);},0);}else{j=q1(j);}}else{jQuery.ajax({url:l=m.url||c1(s),async:m.async,dataType:i,headers:m.headers,success:function(d,r1,s1){j=p1(d);},error:function(d,r1,s1){n1=new Error("resource "+s+" could not be loaded from "+l+". Check for 'file not found' or parse errors. Reason: "+s1);n1.status=r1;n1.error=s1;n1.statusCode=d.status;j=p1(null,n1);}});}if(m.async){return Promise.resolve(o1);}if(n1!=null&&m.failOnError){throw n1;}return j;};jQuery.sap._loadJSResourceAsync=function(s,i){return new Promise(function(d,j){var m=M[s]||(M[s]={state:r});var l=m.url=c1(s);m.state=L;var n1=window.document.createElement('SCRIPT');n1.src=l;n1.setAttribute("data-sap-ui-module",s);n1.addEventListener('load',function(e){jQuery.sap.log.info("Javascript resource loaded: "+s);m.state=R;d();});n1.addEventListener('error',function(e){jQuery.sap.log.error("failed to load Javascript resource: "+s);m.state=D;if(i){d();}else{j();}});t(n1);});};return function(){var m={};jQuery.each(U,function(s,d){m[s]=d.url;});return{modules:M,prefixes:m};};}());function t(o){var d=window.document.getElementsByTagName("head")[0];if(d){d.appendChild(o);}}function u(U,i,l,d){var s=window.document.createElement("script");s.src=U;s.type="text/javascript";if(i){s.id=i;}if(l){jQuery(s).load(function(){l();jQuery(s).off("load");});}if(d){jQuery(s).error(function(){d();jQuery(s).off("error");});}var o;if((i&&(o=jQuery.sap.domById(i))&&o.tagName==="SCRIPT")){jQuery(o).remove();}t(s);}jQuery.sap.includeScript=function includeScript(U,i,l,d){var o=typeof U==="string"?{url:U,id:i}:U;if(typeof U==="string"){u(o.url,o.id,l,d);}else{return new Promise(function(r,R){u(o.url,o.id,r,R);});}};var I;var x=jQuery.sap._mIEStyleSheets={};function y(U,s,l,d){var j=function(U,s,l,d){var L=document.createElement("link");L.type="text/css";L.rel="stylesheet";L.href=U;if(s){L.id=s;}var i=function(){jQuery(L).attr("data-sap-ui-ready","false").off("error");if(d){d();}};var n=function(){jQuery(L).attr("data-sap-ui-ready","true").off("load");if(l){l();}};if(!!sap.ui.Device.browser.internet_explorer){var r=n;n=function(v){var R;try{R=v.target&&v.target.sheet&&v.target.sheet.rules;}catch(w){}if(R&&R.length>0){r();}else{i();}};}jQuery(L).load(n);jQuery(L).error(i);return L;};var m=function(U,s,l,d){if(sap.ui.Device.browser.internet_explorer&&sap.ui.Device.browser.version<=9&&document.styleSheets.length>=28){var r=URI.parse(document.URL).path;var n=new URI(U).absoluteTo(r).toString();if(s){var v=x[s];if(v&&v.href===n){return;}}jQuery.sap.log.warning("Stylesheet "+(s?s+" ":"")+"not added as LINK because of IE limits",U,"jQuery.sap.includeStyleSheet");if(!I){I=document.createStyleSheet();}var w=false;for(var i=0;i<I.imports.length;i++){var B=I.imports[i];if(B.imports.length<30){B.addImport(n);w=true;break;}}if(!w){I.addImport(n);}if(s){x[s]={href:n};}var D=document.getElementById('sap-ui-core-customcss');if(!jQuery.isEmptyObject(D)){t(D);}}else{var L=j(U,s,l,d);if(jQuery('#sap-ui-core-customcss').length>0){jQuery('#sap-ui-core-customcss').first().before(jQuery(L));}else{t(L);}}};var o=jQuery.sap.domById(s);if(o&&o.tagName==="LINK"&&o.rel==="stylesheet"){if(l||d||o.href!==URI(String(U),URI().search("")).toString()){jQuery(o).replaceWith(j(U,s,l,d));}}else{m(U,s,l,d);}}jQuery.sap.includeStyleSheet=function includeStyleSheet(U,i,l,d){var o=typeof U==="string"?{url:U,id:i}:U;if(typeof U==="string"){y(o.url,o.id,l,d);}else{return new Promise(function(r,R){y(o.url,o.id,r,R);});}};if(!(p.productive===true||p.productive==="true"||p.productive==="x")){jQuery(function(){jQuery(document.body).keydown(function(e){if(e.keyCode==80&&e.shiftKey&&e.altKey&&e.ctrlKey){try{jQuery.sap.require("sap.ui.debug.TechnicalInfo");}catch(d){return;}sap.ui.debug.TechnicalInfo.open(function(){var i=q();return{modules:i.modules,prefixes:i.prefixes,config:p};});}});});jQuery(function(){jQuery(document.body).keydown(function(e){if(e.keyCode==83&&e.shiftKey&&e.altKey&&e.ctrlKey){try{jQuery.sap.require("sap.ui.core.support.Support");var s=sap.ui.core.support.Support.getStub();if(s.getType()!=sap.ui.core.support.Support.StubType.APPLICATION){return;}s.openSupportTool();}catch(d){}}});});}if(!jQuery.support){jQuery.support={};}jQuery.extend(jQuery.support,{touch:sap.ui.Device.support.touch});var P=["Webkit","ms","Moz"];var z=document.documentElement.style;var A=function(d,j){if(jQuery.support[d]===undefined){if(z[j]!==undefined){jQuery.support[d]=true;if(j==="boxFlex"||j==="flexOrder"||j==="flexGrow"){if(!sap.ui.Device.browser.chrome||sap.ui.Device.browser.version>28){jQuery.support.flexBoxPrefixed=false;}}return;}else{j=j.charAt(0).toUpperCase()+j.slice(1);for(var i in P){if(z[P[i]+j]!==undefined){jQuery.support[d]=true;return;}}}jQuery.support[d]=false;}};A("cssTransforms","transform");A("cssTransforms3d","perspective");A("cssTransitions","transition");A("cssAnimations","animationName");if(jQuery.support.cssGradients===undefined){var E=document.createElement('div'),z=E.style;try{z.backgroundImage="linear-gradient(left top, red, white)";z.backgroundImage="-moz-linear-gradient(left top, red, white)";z.backgroundImage="-webkit-linear-gradient(left top, red, white)";z.backgroundImage="-ms-linear-gradient(left top, red, white)";z.backgroundImage="-webkit-gradient(linear, left top, right bottom, from(red), to(white))";}catch(e){}jQuery.support.cssGradients=(z.backgroundImage&&z.backgroundImage.indexOf("gradient")>-1);E=null;}jQuery.support.flexBoxPrefixed=true;A("flexBoxLayout","boxFlex");A("newFlexBoxLayout","flexGrow");if(!jQuery.support.newFlexBoxLayout&&z.msFlexOrder!==undefined){jQuery.support.ie10FlexBoxLayout=true;}else{jQuery.support.ie10FlexBoxLayout=false;}if(jQuery.support.flexBoxLayout||jQuery.support.newFlexBoxLayout||jQuery.support.ie10FlexBoxLayout){jQuery.support.hasFlexBoxSupport=true;}else{jQuery.support.hasFlexBoxSupport=false;}var F=function(s){this.mSettings=s||{};this.sMode=this.mSettings.mode||F.Mode.ALLOW;this.fnCallback=this.mSettings.callback;this.iTimeout=this.mSettings.timeout||10000;this.bBlockEvents=this.mSettings.blockEvents!==false;this.bShowBlockLayer=this.mSettings.showBlockLayer!==false;this.bAllowSameOrigin=this.mSettings.allowSameOrigin!==false;this.sParentOrigin='';this.bUnlocked=false;this.bRunnable=false;this.bParentUnlocked=false;this.bParentResponded=false;this.sStatus="pending";this.aFPChilds=[];var d=this;this.iTimer=setTimeout(function(){d._callback(false);},this.iTimeout);var H=function(){d._handlePostMessage.apply(d,arguments);};F.__window.addEventListener('message',H);if(F.__parent===F.__self||F.__parent==null||this.sMode===F.Mode.ALLOW){this._applyState(true,true);}else{this._lock();if(this.sMode===F.Mode.DENY){this._callback(false);return;}if(this.bAllowSameOrigin){try{var o=F.__parent;var O=false;var T=true;do{var i=o.document.domain;if(o==F.__top){if(i!=undefined){O=true;}break;}o=o.parent;}while(T);if(O){this._applyState(true,true);}}catch(e){this._sendRequireMessage();}}else{this._sendRequireMessage();}}};F.Mode={TRUSTED:'trusted',ALLOW:'allow',DENY:'deny'};F.__window=window;F.__parent=parent;F.__self=self;F.__top=top;F._events=["mousedown","mouseup","click","dblclick","mouseover","mouseout","touchstart","touchend","touchmove","touchcancel","keydown","keypress","keyup"];F.prototype.match=function(s,d){if(!(/\*/i.test(d))){return s==d;}else{d=d.replace(/\//gi,"\\/");d=d.replace(/\./gi,"\\.");d=d.replace(/\*/gi,".*");d=d.replace(/:\.\*$/gi,":\\d*");if(d.substr(d.length-1,1)!=='$'){d=d+'$';}if(d.substr(0,1)!=='^'){d='^'+d;}var r=new RegExp(d,'i');return r.test(s);}};F._lockHandler=function(o){o.stopPropagation();o.preventDefault();};F.prototype._createBlockLayer=function(){if(document.readyState=="complete"){var l=document.createElement("div");l.style.position="absolute";l.style.top="0px";l.style.bottom="0px";l.style.left="0px";l.style.right="0px";l.style.opacity="0";l.style.backgroundColor="white";l.style.zIndex=2147483647;document.body.appendChild(l);this._lockDiv=l;}};F.prototype._setCursor=function(){if(this._lockDiv){this._lockDiv.style.cursor=this.sStatus=="denied"?"not-allowed":"wait";}};F.prototype._lock=function(){var d=this;if(this.bBlockEvents){for(var i=0;i<F._events.length;i++){document.addEventListener(F._events[i],F._lockHandler,true);}}if(this.bShowBlockLayer){this._blockLayer=function(){d._createBlockLayer();d._setCursor();};if(document.readyState=="complete"){this._blockLayer();}else{document.addEventListener("readystatechange",this._blockLayer);}}};F.prototype._unlock=function(){if(this.bBlockEvents){for(var i=0;i<F._events.length;i++){document.removeEventListener(F._events[i],F._lockHandler,true);}}if(this.bShowBlockLayer){document.removeEventListener("readystatechange",this._blockLayer);if(this._lockDiv){document.body.removeChild(this._lockDiv);delete this._lockDiv;}}};F.prototype._callback=function(s){this.sStatus=s?"allowed":"denied";this._setCursor();clearTimeout(this.iTimer);if(typeof this.fnCallback==='function'){this.fnCallback.call(null,s);}};F.prototype._applyState=function(i,d){if(this.bUnlocked){return;}if(i){this.bRunnable=true;}if(d){this.bParentUnlocked=true;}if(!this.bRunnable||!this.bParentUnlocked){return;}this._unlock();this._callback(true);this._notifyChildFrames();this.bUnlocked=true;};F.prototype._applyTrusted=function(T){if(T){this._applyState(true,false);}else{this._callback(false);}};F.prototype._check=function(d){if(this.bRunnable){return;}var T=false;if(this.bAllowSameOrigin&&this.sParentOrigin&&F.__window.document.URL.indexOf(this.sParentOrigin)==0){T=true;}else if(this.mSettings.whitelist&&this.mSettings.whitelist.length!=0){var H=this.sParentOrigin.split('//')[1];H=H.split(':')[0];for(var i=0;i<this.mSettings.whitelist.length;i++){var m=H.indexOf(this.mSettings.whitelist[i]);if(m!=-1&&H.substring(m)==this.mSettings.whitelist[i]){T=true;break;}}}if(T){this._applyTrusted(T);}else if(this.mSettings.whitelistService){var j=this;var l=new XMLHttpRequest();var n=this.mSettings.whitelistService+'?parentOrigin='+encodeURIComponent(this.sParentOrigin);l.onreadystatechange=function(){if(l.readyState==4){j._handleXmlHttpResponse(l,d);}};l.open('GET',n,true);l.setRequestHeader('Accept','application/json');l.send();}else{this._callback(false);}};F.prototype._handleXmlHttpResponse=function(d,i){if(d.status===200){var T=false;var r=d.responseText;var R=JSON.parse(r);if(R.active==false){this._applyState(true,true);}else if(i){return;}else{if(this.match(this.sParentOrigin,R.origin)){T=R.framing;}this._applyTrusted(T);}}else{jQuery.sap.log.warning("The configured whitelist service is not available: "+d.status);this._callback(false);}};F.prototype._notifyChildFrames=function(){for(var i=0;i<this.aFPChilds.length;i++){this.aFPChilds[i].postMessage('SAPFrameProtection*parent-unlocked','*');}};F.prototype._sendRequireMessage=function(){F.__parent.postMessage('SAPFrameProtection*require-origin','*');if(this.mSettings.whitelistService){setTimeout(function(){if(!this.bParentResponded){this._check(true);}}.bind(this),10);}};F.prototype._handlePostMessage=function(o){var s=o.source,d=o.data;if(s===F.__self||s==null||typeof d!=="string"||d.indexOf("SAPFrameProtection*")===-1){return;}if(s===F.__parent){this.bParentResponded=true;if(!this.sParentOrigin){this.sParentOrigin=o.origin;this._check();}if(d=="SAPFrameProtection*parent-unlocked"){this._applyState(false,true);}}else if(s.parent===F.__self&&d=="SAPFrameProtection*require-origin"&&this.bUnlocked){s.postMessage("SAPFrameProtection*parent-unlocked","*");}else{s.postMessage("SAPFrameProtection*parent-origin","*");this.aFPChilds.push(s);}};jQuery.sap.FrameOptions=F;}());
jQuery.sap.globalEval=function(){"use strict";eval(arguments[0]);};
