/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','./ExpressionParser','sap/ui/model/BindingMode','jquery.sap.script'],function(q,E,B){"use strict";var a={_keepBindingStrings:false};var r=/^\{\s*[a-zA-Z_][a-zA-Z0-9_]*\s*:/;var b=/(\\[\\\{\}])|(\{)/g;var c=/([\\\{\}])/g;function d(F,R){function e(){var i,n=F.length,k=new Array(n);for(i=0;i<n;i+=1){k[i]=F[i].apply(this,arguments);}if(R){return R.apply(this,k);}return n>1?k.join(" "):k[0];}e.textFragments=R&&R.textFragments||"sap.ui.base.BindingParser: composeFormatters";return e;}function f(F){var e=function(){var R=[],l=F.length,i;for(i=0;i<l;i++){if(typeof F[i]==="number"){R.push(arguments[F[i]]);}else{R.push(F[i]);}}return R.join('');};e.textFragments=F;return e;}function g(p){var P=p.indexOf(">"),o={path:p};if(P>0){o.model=p.slice(0,P);o.path=p.slice(P+1);}return o;}function h(o,s){try{a.mergeParts(o);}catch(e){q.sap.log.error("Cannot merge parts: "+e.message,s,"sap.ui.base.BindingParser");}}function j(e,i,s){var p=q.sap.parseJS,P,k;function l(o,u){if(typeof o[u]==="string"){var v,N=o[u];if(q.sap.startsWith(o[u],".")){v=q.sap.getObject(o[u].slice(1),undefined,e.oContext);o[u]=e.bStaticContext?v:q.proxy(v,e.oContext);}else{o[u]=q.sap.getObject(o[u]);}if(typeof(o[u])!=="function"){if(e.bTolerateFunctionsNotFound){e.aFunctionsNotFound=e.aFunctionsNotFound||[];e.aFunctionsNotFound.push(N);}else{q.sap.log.error(u+" function "+N+" not found!");}}}}function m(o,u){var F;if(typeof o[u]==="string"){if(q.sap.startsWith(o[u],".")){F=q.sap.getObject(o[u].slice(1),undefined,e.oContext);}else{F=q.sap.getObject(o[u]);}if(typeof F==="function"){o[u]=new F(o.formatOptions,o.constraints);}else{o[u]=F;}delete o.formatOptions;delete o.constraints;}}function n(o,u){if(!(q.isPlainObject(o[u]))){return;}q.each(o[u],function(N,O){l(o[u],N);});}function t(o,u,v){var F;if(!(typeof o[u]==="object"||q.isArray(o[u]))){return;}if(q.isArray(o[u])){q.each(o[u],function(I,O){t(o[u],I,u);});}else{if(u==="filters"||v==="filters"){F=q.sap.getObject("sap.ui.model.Filter");}else if(u==="sorter"||v==="sorter"){F=q.sap.getObject("sap.ui.model.Sorter");l(o[u],"group");}if(F){o[u]=new F(o[u]);}}}if(r.test(i.slice(s))){P=p(i,s);m(P.result,'type');t(P.result,'filters');t(P.result,'sorter');n(P.result,'events');l(P.result,'formatter');l(P.result,'factory');l(P.result,'groupHeaderFactory');return P;}k=i.indexOf('}',s);if(k<s){throw new SyntaxError("no closing braces found in '"+i+"' after pos:"+s);}return{result:g(i.slice(s+1,k)),at:k+1};}a.simpleParser=function(s,C){if(q.sap.startsWith(s,"{")&&q.sap.endsWith(s,"}")){return g(s.slice(1,-1));}};a.simpleParser.escape=function(v){return v;};a.complexParser=function(s,C,u,t,S){var e=false,o={parts:[]},M=false,i={oContext:C,aFunctionsNotFound:undefined,bStaticContext:S,bTolerateFunctionsNotFound:t},F=[],U,p=0,m,k;function l(I,n,v){var w=E.parse(j.bind(null,i),s,n);function x(w,y){if(w.parts){w.parts.forEach(x);e=e||y!==undefined;}else{w.mode=v;}}if(I.charAt(w.at)!=="}"){throw new SyntaxError("Expected '}' and instead saw '"+I.charAt(w.at)+"' in expression binding "+I+" at position "+w.at);}w.at+=1;if(w.result){x(w.result);}else{F[F.length-1]=String(w.constant);U=true;}return w;}b.lastIndex=0;while((m=b.exec(s))!==null){if(p<m.index){F.push(s.slice(p,m.index));}if(m[1]){F.push(m[1].slice(1));U=true;}else{F.push(o.parts.length);if(s.indexOf(":=",m.index)===m.index+1){k=l(s,m.index+3,B.OneTime);}else if(s.charAt(m.index+1)==="="){k=l(s,m.index+2,B.OneWay);}else{k=j(i,s,m.index);}if(k.result){o.parts.push(k.result);M=M||"parts"in k.result;}b.lastIndex=k.at;}p=b.lastIndex;}if(p<s.length){F.push(s.slice(p));}if(o.parts.length>0){if(F.length===1){o=o.parts[0];M=e;}else{o.formatter=f(F);}if(M){h(o,s);}if(a._keepBindingStrings){o.bindingString=s;}if(i.aFunctionsNotFound){o.functionsNotFound=i.aFunctionsNotFound;}return o;}else if(u&&U){return F.join('');}};a.complexParser.escape=function(v){return v.replace(c,"\\$1");};a.mergeParts=function(o){var F=[],p=[];o.parts.forEach(function(e){var i,k=function(){return e;},n,s=p.length;function l(){return arguments[s];}if(e&&typeof e==="object"){if(e.parts){for(n in e){if(n!=="formatter"&&n!=="parts"){throw new Error("Unsupported property: "+n);}}p=p.concat(e.parts);i=p.length;if(e.formatter){k=function(){return e.formatter.apply(this,Array.prototype.slice.call(arguments,s,i));};}else if(i-s>1){k=function(){return Array.prototype.slice.call(arguments,s,i).join(" ");};}else{k=l;}}else if(e.path){p.push(e);k=l;}}F.push(k);});o.parts=p;o.formatter=d(F,o.formatter);};a.parseExpression=function(i,s){return E.parse(j.bind(null,{}),i,s);};return a;},true);
