/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/thirdparty/URI','jquery.sap.strings'],function(q,U){"use strict";
//License granted by Douglas Crockford to SAP, Apache License 2.0
//    (http://www.apache.org/licenses/LICENSE-2.0)
var u=f.bind(null,undefined),d={"Array":Array,"Boolean":Boolean,"Date":Date,"encodeURIComponent":encodeURIComponent,"Infinity":Infinity,"isFinite":isFinite,"isNaN":isNaN,"JSON":JSON,"Math":Math,"NaN":NaN,"Number":Number,"Object":Object,"odata":{"compare":function(){var O;q.sap.require("sap.ui.model.odata.ODataUtils");O=sap.ui.require("sap/ui/model/odata/ODataUtils");return O.compare.apply(O,arguments);},"fillUriTemplate":function(){if(!U.expand){q.sap.require("sap.ui.thirdparty.URITemplate");}return U.expand.apply(U,arguments).toString();},"uriEncode":function(){var O;q.sap.require("sap.ui.model.odata.ODataUtils");O=sap.ui.require("sap/ui/model/odata/ODataUtils");return O.formatValue.apply(O,arguments);}},"parseFloat":parseFloat,"parseInt":parseInt,"RegExp":RegExp,"String":String,"undefined":undefined},r=/\d/,E="sap.ui.base.ExpressionParser",a=/[a-z]\w*/i,b=/[a-z]/i,p=[E],P=E+"#parse",s={"BINDING":{led:l,nud:function(T,e){return B.bind(null,T.value);}},"IDENTIFIER":{led:l,nud:function(T,e){if(!(T.value in e.globals)){q.sap.log.warning("Unsupported global identifier '"+T.value+"' in expression parser input '"+e.input+"'",undefined,E);}return f.bind(null,e.globals[T.value]);}},"CONSTANT":{led:l,nud:function(T,e){return f.bind(null,T.value);}},".":{lbp:18,led:function(T,e,L){return D.bind(null,L,e.advance("IDENTIFIER").value);},nud:l},"(":{lbp:17,led:function(T,e,L){var i=[],v=true;while(e.current().id!==")"){if(v){v=false;}else{e.advance(",");}i.push(e.expression(0));}e.advance(")");return F.bind(null,L,i);},nud:function(T,e){var v=e.expression(0);e.advance(")");return v;}},"[":{lbp:18,led:function(T,e,L){var N=e.expression(0);e.advance("]");return g.bind(null,L,N);},nud:function(T,e){var i=[],v=true;while(e.current().id!=="]"){if(v){v=false;}else{e.advance(",");}i.push(e.current().id===","?u:e.expression(0));}e.advance("]");return A.bind(null,i);}},"!":{lbp:15,led:l,nud:function(T,e){return h.bind(null,e.expression(this.lbp),function(x){return!x;});}},"typeof":{lbp:15,led:l,nud:function(T,e){return h.bind(null,e.expression(this.lbp),function(x){return typeof x;});}},"?":{lbp:4,led:function(T,e,L){var i,v;v=e.expression(this.lbp-1);e.advance(":");i=e.expression(this.lbp-1);return C.bind(null,L,v,i);},nud:l},")":{led:l,nud:l},"]":{led:l,nud:l},"{":{led:l,nud:function(T,e){var i=true,K,v={},V;while(e.current().id!=="}"){if(i){i=false;}else{e.advance(",");}if(e.current()&&e.current().id==="CONSTANT"&&typeof e.current().value==="string"){K=e.advance().value;}else{K=e.advance("IDENTIFIER").value;}e.advance(":");V=e.expression(0);v[K]=V;}e.advance("}");return M.bind(null,v);}},"}":{lbp:-1,led:l,nud:l},",":{led:l,nud:l},":":{led:l,nud:l}},t=["===","!==","!","||","&&",".","(",")","{","}",":",",","?","*","/","%","+","-","<=","<",">=",">","[","]"],c;t.forEach(function(T,i){t[i]=q.sap.escapeRegExp(T);});c=new RegExp(t.join("|"),"g");j("*",14,function(x,y){return x*y;});j("/",14,function(x,y){return x/y;});j("%",14,function(x,y){return x%y;});j("+",13,function(x,y){return x+y;}).nud=function(T,e){return h.bind(null,e.expression(this.lbp),function(x){return+x;});};j("-",13,function(x,y){return x-y;}).nud=function(T,e){return h.bind(null,e.expression(this.lbp),function(x){return-x;});};j("<=",11,function(x,y){return x<=y;});j("<",11,function(x,y){return x<y;});j(">=",11,function(x,y){return x>=y;});j(">",11,function(x,y){return x>y;});j("in",11,function(x,y){return x in y;});j("===",10,function(x,y){return x===y;});j("!==",10,function(x,y){return x!==y;});j("&&",7,function(x,y){return x&&y();},true);j("||",6,function(x,y){return x||y();},true);function A(e,v){var R=[];e.forEach(function(w,i){R[i]=w(v);});return R;}function B(i,e){return e[i];}function C(e,T,i,v){return e(v)?T(v):i(v);}function f(v){return v;}function D(L,i,e){var v=L(e),w=v[i];return typeof w==="function"?w.bind(v):w;}function F(L,e,v){var R=[];e.forEach(function(w,i){R[i]=w(v);});return L(v).apply(null,R);}function I(L,R,O,e,i){return O(L(i),e?R.bind(null,i):R(i));}function M(e,i){var K,R={};for(K in e){R[K]=e[K](i);}return R;}function g(L,N,e){return L(e)[N(e)];}function h(R,O,e){return O(R(e));}function j(i,e,O,L){s[i]={lbp:e,led:function(T,v,w){var x=L?this.lbp-1:this.lbp;return I.bind(null,w,v.expression(x),O,L);},nud:l};return s[i];}function k(e,i,v){var w=new SyntaxError(e);w.at=v;w.text=i;if(v!==undefined){e+=" at position "+v;}q.sap.log.error(e,i,E);throw w;}function l(T){var e=T.input.slice(T.start,T.end);k("Unexpected "+T.id+(e!==T.id?": "+e:""),T.input,T.start+1);}function m(R,v,S){var w=[],x=[],t=[],T=q.sap._createJSTokenizer();function y(G,S){var H,i;function J(){var K;for(K in G){if(K!=="path"&&K!=="model"){return true;}}return false;}if(J()){H=q.sap.parseJS(v,S).result;}else{H=G;}for(i=0;i<x.length;i+=1){if(q.sap.equal(w[i],H)){return i;}}w[i]=H;x[i]=G;return i;}function z(){var i,G,H,J,K;T.white();i=T.getCh();H=T.getIndex();if(b.test(i)){J=a.exec(v.slice(H));switch(J[0]){case"false":case"null":case"true":K={id:"CONSTANT",value:T.word()};break;case"in":case"typeof":K={id:J[0]};T.setIndex(H+J[0].length);break;default:K={id:"IDENTIFIER",value:J[0]};T.setIndex(H+J[0].length);}}else if(r.test(i)||i==="."&&r.test(v.charAt(T.getIndex()+1))){K={id:"CONSTANT",value:T.number()};}else if(i==="'"||i==='"'){K={id:"CONSTANT",value:T.string()};}else if(i==="$"){T.next("$");T.next("{");G=R(v,T.getIndex()-1);K={id:"BINDING",value:y(G.result,H+1)};T.setIndex(G.at);}else{c.lastIndex=H;J=c.exec(v);if(!J||J.index!==H){return false;}K={id:J[0]};T.setIndex(H+J[0].length);}K.input=v;K.start=H;K.end=T.getIndex();t.push(K);return true;}T.init(v,S);try{while(z()){}}catch(e){if(e.name==="SyntaxError"){k(e.message,e.text,e.at);}else{throw e;}}return{at:T.getIndex(),parts:x,tokens:t};}function n(e,i){return function(){try{return e.apply(this,arguments);}catch(v){q.sap.log.warning(String(v),i,E);}};}function o(t,i,G){var e,N=0,v={advance:w,current:x,expression:y,globals:G,input:i},T;function w(z){var T=t[N];if(z){if(!T){k("Expected "+z+" but instead saw end of input",i);}else if(T.id!==z){k("Expected "+z+" but instead saw "+i.slice(T.start,T.end),i,T.start+1);}}N+=1;return T;}function x(){return t[N];}function y(z){var L;T=w();if(!T){k("Expected expression but instead saw end of input",i);}L=s[T.id].nud(T,v);while(N<t.length){T=x();if(z>=(s[T.id].lbp||0)){break;}w();L=s[T.id].led(T,v,L);}return L;}e=y(0);return{at:x()?x().start:undefined,formatter:n(e,i)};}return{parse:function(R,i,S,G){var e,T;q.sap.measure.average(P,"",p);T=m(R,i,S);e=o(T.tokens,i,G||d);q.sap.measure.end(P);if(!T.parts.length){return{constant:e.formatter(),at:e.at||T.at};}function v(){return e.formatter(arguments);}v.textFragments=true;return{result:{formatter:v,parts:T.parts},at:e.at||T.at};}};},true);
