/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/base/ManagedObject','./mvc/View','./ExtensionPoint','./StashedControlSupport'],function(q,M,V,E,S){"use strict";function p(t,v,n,c){var b=M.bindingParser(v,c,true);if(b&&typeof b==="object"){return b;}var a=v=b||v;var T=sap.ui.base.DataType.getType(t);if(T){if(T instanceof sap.ui.base.DataType){a=T.parseValue(v);}}else{throw new Error("Property "+n+" has unknown type "+t);}return typeof a==="string"?M.bindingParser.escape(a):a;}function l(x){return x.localName||x.baseName||x.nodeName;}var X={};X.loadTemplate=function(t,e){var r=q.sap.getResourceName(t,"."+(e||"view")+".xml");return q.sap.loadResource(r).documentElement;};X.parseViewAttributes=function(x,v,s){var a=v.getMetadata().getAllProperties();for(var i=0;i<x.attributes.length;i++){var b=x.attributes[i];if(b.name==='controllerName'){v._controllerName=b.value;}else if(b.name==='resourceBundleName'){v._resourceBundleName=b.value;}else if(b.name==='resourceBundleUrl'){v._resourceBundleUrl=b.value;}else if(b.name==='resourceBundleLocale'){v._resourceBundleLocale=b.value;}else if(b.name==='resourceBundleAlias'){v._resourceBundleAlias=b.value;}else if(b.name==='class'){v.addStyleClass(b.value);}else if(!s[b.name]&&a[b.name]){s[b.name]=p(a[b.name].type,b.value,b.name,v._oContainingView.oController);}}};X.parseTemplate=function(x,v){var r=[];var c=v.sViewName||v._sFragmentName;if(!c){var t=v;var L=0;while(++L<1000&&t&&t!==t._oContainingView){t=t._oContainingView;}c=t.sViewName;}if(v.isSubView()){a(x,true);}else{if(x.localName==="View"&&x.namespaceURI!=="sap.ui.core.mvc"){q.sap.log.warning("XMLView root node must have the 'sap.ui.core.mvc' namespace, not '"+x.namespaceURI+"'"+(c?" (View name: "+c+")":""));}b(x);}return r;function a(x,R,I){if(x.nodeType===1){var s=l(x);if(x.namespaceURI==="http://www.w3.org/1999/xhtml"||x.namespaceURI==="http://www.w3.org/2000/svg"){r.push("<"+s+" ");for(var i=0;i<x.attributes.length;i++){var h=x.attributes[i];var j=h.value;if(h.name==="id"){j=v._oContainingView.createId(j);}r.push(h.name+"=\""+q.sap.encodeHTML(j)+"\" ");}if(R===true){r.push("data-sap-ui-preserve"+"=\""+v.getId()+"\" ");}r.push(">");if(window.HTMLTemplateElement&&x instanceof HTMLTemplateElement&&x.content instanceof DocumentFragment){b(x.content);}else{b(x);}r.push("</"+s+">");}else if(s==="FragmentDefinition"&&x.namespaceURI==="sap.ui.core"){b(x,false,true);}else{var C=e(x);for(var i=0;i<C.length;i++){var o=C[i];if(v.getMetadata().hasAggregation("content")){v.addAggregation("content",o);}else if(v.getMetadata().hasAssociation(("content"))){v.addAssociation("content",o);}r.push(o);}}}else if(x.nodeType===3&&!I){var k=x.textContent||x.text,m=l(x.parentNode);if(k){if(m!="style"){k=q.sap.encodeHTML(k);}r.push(k);}}}function b(x,R,I){var h=x.childNodes;for(var i=0;i<h.length;i++){a(h[i],R,I);}}function f(n,s){var C;var m=sap.ui.getCore().getLoadedLibraries();q.each(m,function(h,i){if(n===i.namespace||n===i.name){C=i.name+"."+((i.tagNames&&i.tagNames[s])||s);}});C=C||n+"."+s;q.sap.require(C);var o=q.sap.getObject(C);if(o){return o;}else{q.sap.log.error("Can't find object class '"+C+"' for XML-view","","XMLTemplateProcessor.js");}}function d(n){if(n.namespaceURI==="http://www.w3.org/1999/xhtml"||n.namespaceURI==="http://www.w3.org/2000/svg"){var i=n.attributes['id']?n.attributes['id'].textContent||n.attributes['id'].text:null;return[new sap.ui.core.mvc.XMLView({id:i?v._oContainingView.createId(i):undefined,xmlNode:n,containingView:v._oContainingView})];}else{return e(n);}}function e(n){if(l(n)==="ExtensionPoint"&&n.namespaceURI==="sap.ui.core"){return sap.ui.extensionpoint(v,n.getAttribute("name"),function(){var h=n.childNodes;var D=[];for(var i=0;i<h.length;i++){var C=h[i];if(C.nodeType===1){D=q.merge(D,d(C));}}return D;});}else{return g(n);}}function g(n){var h=n.namespaceURI,C=f(h,l(n)),s={},k="",m=[];if(!C){return[];}var o=C.getMetadata();var K=o.getAllSettings();for(var i=0;i<n.attributes.length;i++){var u=n.attributes[i],N=u.name,I=K[N],w=u.value;if(N==="id"){s[N]=v._oContainingView.createId(w);}else if(N==="class"){k+=w;}else if(N==="viewName"){s[N]=w;}else if(N==="fragmentName"){s[N]=w;s['containingView']=v._oContainingView;}else if((N==="binding"&&!I)||N==='objectBindings'){var B=M.bindingParser(w,v._oContainingView.oController);s.objectBindings=s.objectBindings||{};s.objectBindings[B.model||undefined]=B;}else if(N.indexOf(":")>-1){if(u.namespaceURI==="http://schemas.sap.com/sapui5/extension/sap.ui.core.CustomData/1"){var y=l(u);m.push(new sap.ui.core.CustomData({key:y,value:p("any",w,y,v._oContainingView.oController)}));}else if(N.indexOf("xmlns:")!==0){q.sap.log.warning(v+": XMLView parser encountered and ignored attribute '"+N+"' (value: '"+w+"') with unknown namespace");}}else if(I&&I._iKind===0){s[N]=p(I.type,w,N,v._oContainingView.oController);}else if(I&&I._iKind===1&&I.altTypes){s[N]=p(I.altTypes[0],w,N,v._oContainingView.oController);}else if(I&&I._iKind===2){var B=M.bindingParser(w,v._oContainingView.oController);if(B){s[N]=B;}else{q.sap.log.error(v+": aggregations with cardinality 0..n only allow binding paths as attribute value (wrong value: "+N+"='"+w+"')");}}else if(I&&I._iKind===3){s[N]=v._oContainingView.createId(w);}else if(I&&I._iKind===4){s[N]=q.map(w.split(/[\s,]+/g),function(j){return j?v._oContainingView.createId(j):null;});}else if(I&&I._iKind===5){var z=V._resolveEventHandler(w,v._oContainingView.oController);if(z){s[N]=z;}else{q.sap.log.warning(v+": event handler function \""+w+"\" is not a function or does not exist in the controller.");}}else if(I&&I._iKind===-1){if(sap.ui.core.mvc.View.prototype.isPrototypeOf(C.prototype)&&N=="async"){s[N]=p(I.type,w,N,v._oContainingView.oController);}else{q.sap.log.warning(v+": setting '"+N+"' for class "+o.getName()+" (value:'"+w+"') is not supported");}}else{}}if(m.length>0){s.customData=m;}function A(n,F,G){var j;for(j=n.firstChild;j;j=j.nextSibling){D(n,F,G,j);}}function D(n,F,G,J,O){var P;if(J.nodeType===1){P=J.namespaceURI===h&&G&&G[l(J)];if(P){A(J,P);}else if(F){if(!O&&J.getAttribute("stashed")==="true"){S.createStashedControl(v._oContainingView.createId(J.getAttribute("id")),{stashedAlias:J.getAttribute("stashedAlias"),sParentId:s["id"],sParentAggregationName:F.name,fnCreate:function(){return D(n,F,G,J,true);}});return;}var Q=d(J);for(var j=0;j<Q.length;j++){var R=Q[j];var T=F.name;if(F.multiple){if(!s[T]){s[T]=[];}if(typeof s[T].path==="string"){s[T].template=R;}else{s[T].push(R);}}else{s[T]=R;}}return Q;}else if(l(n)!=="FragmentDefinition"||n.namespaceURI!=="sap.ui.core"){throw new Error("Cannot add direct child without default aggregation defined for control "+o.getElementName());}}else if(J.nodeType===3){if(q.trim(J.textContent||J.text)){throw new Error("Cannot add text nodes as direct child of an aggregation. For adding text to an aggregation, a surrounding html tag is needed: "+q.trim(J.textContent||J.text));}}return[];}var F=o.getDefaultAggregation();var G=o.getAllAggregations();A(n,F,G);var H;if(sap.ui.core.mvc.View.prototype.isPrototypeOf(C.prototype)&&typeof C._sType==="string"){H=sap.ui.view(s,undefined,C._sType);}else{H=new C(s);}if(k&&H.addStyleClass){H.addStyleClass(k);}if(!H){H=[];}else if(!q.isArray(H)){H=[H];}return H;}};return X;},true);
