/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/core/Core','./Template','sap/ui/thirdparty/handlebars','sap/ui/base/ManagedObject'],function(q,C,T,H,M){"use strict";var a=T.extend("sap.ui.core.tmpl.HandlebarsTemplate",{constructor:function(i,s){T.apply(this,arguments);}});T.registerType("text/x-handlebars-template","sap.ui.core.tmpl.HandlebarsTemplate");function d(h){for(var k in h){h[k]=h[k].replace("&gt;",">").replace("&lt;","<").replace("&quot;","\"").replace("&amp;","&");}}function b(p,P){var r=/^((\w+)>)?(.*)/,c=r.exec(p),s=c[2],e=r.exec(P),f=e[2];var c=r.exec(p);if(P&&s==f){return P+c[3];}else{return p;}}a.RENDER_HELPERS=(function(){var e=H.helpers["each"],w=H.helpers["with"],I=H.helpers["if"],u=H.helpers["unless"],r=sap.ui.getCore().createRenderManager();r.renderControl=function(c){this.writeControlData(c);this.writeClasses(c);this.writeStyles(c);};var h={"each":function(c,o){o=o||c;if(!o.hash.path){return e.apply(this,arguments);}else{d(o.hash);var R=o.data.renderManager,f=o.data.rootControl,p=o.data.path,P=o.data.parentControl,s=b(o.hash.path,p),g=f.bindList(s),i=[],j;if(o.data){j=H.createFrame(o.data);}if(g){for(var k in g){if(j){j.renderManager=R;j.rootControl=f;j.path=s+"/"+k+"/";j.parentControl=P;}i.push(o.fn({},{data:j}));}}if(!P){return new H.SafeString(i.join(""));}}},"with":function(c,o){o=o||c;if(!o.hash.path){return w.apply(this,arguments);}},"if":function(c,o){o=o||c;if(!o.hash.path){return I.apply(this,arguments);}else{d(o.hash);var R=o.data.rootControl,p=o.data.path,P=b(o.hash.path,p);if(P){var v=R.bindProp(P);if(v){return o.fn(this);}else{return o.inverse(this);}}}},"unless":function(c,o){o=o||c;if(!o.hash.path){return u.apply(this,arguments);}else{d(o.hash);var R=o.data.rootControl,p=o.data.path,P=b(o.hash.path,p);if(P){var v=R.bindProp(P);if(!v){return o.fn(this);}else{return o.inverse(this);}}}},"text":function(c,o){o=o||c;d(o.hash);var R=o.data.rootControl,p=o.data.path,P=b(o.hash.path,p);if(P){var v=R.bindProp(P);return v&&new H.SafeString(q.sap.encodeHTML(v));}else{throw new Error("The expression \"text\" requires the option \"path\"!");}},"element":function(c,o){o=o||c;d(o.hash);var R=o.data.renderManager,f=o.data.rootControl,E=f.createDOMElement(o.hash,o.data.path),p=o.data.parentElement;if(o.fn){o.fn({},{data:{renderManager:R,rootControl:f,parentElement:E}});}if(p){p.addElement(E);return;}return new H.SafeString(R.getHTML(E));},"control":function(c,o){o=o||c;d(o.hash);var R=o.data.renderManager,f=o.data.control;if(f){return new H.SafeString(R.getHTML(f));}var g=o.data.rootControl,p=o.data.path,P=o.data.children,t=o.hash["sap-ui-type"],j=q.sap.getObject(t),m=j&&j.getMetadata(),D=o.hash["sap-ui-default-aggregation"]||m&&m.getDefaultAggregationName(),v=o.data.view;if(!j){throw new Error("Control of type "+t+" cannot be found.");}var k={};if(o.fn){o.fn({},{data:{rootControl:g,path:p,children:k,defaultAggregation:D,view:v}});}var s=q.extend({},o.hash),S;for(var K in s){if(K==="sap-ui-class"&&typeof s[K]==="string"){S=s["sap-ui-class"]&&s["sap-ui-class"].split(" ");delete s[K];}else if(k[K]){delete s[K];}}var n=g.createControl(s,o.data.path,!!P,v);if(S&&S.length>0){S.forEach(n.addStyleClass.bind(n));}if(!q.isEmptyObject(k)){s=o.hash;var A=m.getAllAggregations();for(var x in k){var y=k[x];for(var i=0,l=y.length;i<l;i++){var z=y[i],B=A[x],E=B&&B.multiple;if(typeof s[x]==="string"){var F=M.bindingParser(s[x],v&&v.getController());F.template=z;n.bindAggregation(x,F);}else{if(E){n.addAggregation(x,z);}else{n.setAggregation(x,z);}}}}}if(P){var x=o.hash["sap-ui-aggregation"]||o.data.defaultAggregation;P[x]=P[x]||[];P[x].push(n);return;}return new H.SafeString(R.getHTML(n));},"property":function(c,o){o=o||c;d(o.hash);var R=o.data.rootControl,m=R.getMetadata(),p=o.hash.name,g=m.getProperty(p)._sGetter;return R[g]();},"aggregation":function(c,o){o=o||c;d(o.hash);if(o.data.children){var A=o.hash.name;if(o.fn){var D=q.extend({},o.data,{defaultAggregation:A});o.fn({},{data:D});}}else{var R=o.data.renderManager,f=o.data.rootControl,m=f.getMetadata(),A=o.hash.name,g=m.getAggregation(A)._sGetter,j=[];var k=f[g]();if(k){for(var i=0,l=k.length;i<l;i++){if(o.fn){j.push(o.fn({},{data:{renderManager:R,rootControl:f,control:k[i]}}));}else{j.push(R.getHTML(k[i]));}}}return new H.SafeString(j.join(""));}},"event":function(c,o){o=o||c;},"controlData":function(c,o){o=o||c;var R=o.data.rootControl;return new H.SafeString(r.getHTML(R));}};return h;}());a.prototype.createMetadata=function(){var t=this.getContent(),f=this._fnTemplate=this._fnTemplate||H.compile(t);var m={},j=sap.ui.core.tmpl.TemplateControl.getMetadata().getAllSettings(),p=sap.ui.core.tmpl.TemplateControl.getMetadata().getAllPrivateAggregations();var h={"property":function(c,o){o=o||c;d(o.hash);var n=o.hash.name;if(n&&n!=="id"&&!j[n]){m.properties=m.properties||{};m.properties[n]=q.extend({},{type:"string"},o.hash);}else{throw new Error("The property name \""+n+"\" is reserved.");}},"aggregation":function(c,o){o=o||c;d(o.hash);var n=o.hash.name;if(n&&!j[n]&&!p[n]){o.hash.multiple=o.hash.multiple=="true";m.aggregations=m.aggregations||{};m.aggregations[n]=q.extend({},o.hash);}else{throw new Error("The aggregation name \""+n+"\" is reserved.");}},"event":function(c,o){o=o||c;},"controlData":function(c,o){o=o||c;m._hasControlData=true;}};q.each(["each","if","unless","with"],function(i,v){h[v]=function(){};});f({},{helpers:h});return m;};a.prototype.createRenderer=function(v){var t=this.getContent(),f=this._fnTemplate=this._fnTemplate||H.compile(t);var r=function(c,o){var h=f(o.getContext()||{},{data:{renderManager:c,rootControl:o,view:v},helpers:a.RENDER_HELPERS});c.write(h);};return r;};return a;});
