/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/base/BindingParser','sap/ui/base/ManagedObject','sap/ui/core/XMLTemplateProcessor','sap/ui/Device','sap/ui/model/BindingMode','sap/ui/model/CompositeBinding','sap/ui/model/Context'],function(q,B,M,X,D,a,C,b){'use strict';var u={},N="http://schemas.sap.com/sapui5/extension/sap.ui.core.template/1",x="sap.ui.core.util.XMLPreprocessor",p=[x],P=x+"/insertFragment",s=x+"/getResolvedBinding",c=x+".process",W=M.extend("sap.ui.core.util._with",{metadata:{properties:{any:"any"},aggregations:{child:{multiple:false,type:"sap.ui.core.util._with"}}}}),R=W.extend("sap.ui.core.util._repeat",{metadata:{aggregations:{list:{multiple:true,type:"n/a",_doesNotRequireFactory:true}}},updateList:function(){}});function d(w,S,i,v){function h(k){if(!v){v=w.getBinding("any");if(v instanceof C){v=v.getBindings();if(i!==undefined){v=v[i];}}}return Array.isArray(v)?v[k]:v;}function j(o){return o instanceof b?o.getPath():o.getModel().resolve(o.getPath(),o.getContext());}return{getInterface:function(k,m){var o,n,t;if(typeof k==="string"){m=k;k=undefined;}h();if(Array.isArray(v)){if(k>=0&&k<v.length){n=v[k];}else{throw new Error("Invalid index of part: "+k);}}else if(k!==undefined){throw new Error("Not the root formatter of a composite binding");}else if(m){n=v;}else{throw new Error("Missing path");}if(m){t=n.getModel();if(m.charAt(0)!=='/'){o=n instanceof b?n:t.createBindingContext(n.getPath(),n.getContext());}n=t.createBindingContext(m,o);if(!n){throw new Error("Model could not create binding context synchronously: "+t);}}return d(null,S,undefined,n);},getModel:function(k){var o=h(k);return o&&o.getModel();},getPath:function(k){var o=h(k);return o&&j(o);},getSetting:function(n){if(n==="bindingContexts"||n==="models"){throw new Error("Illegal argument: "+n);}return S[n];}};}function g(w,o,S){function h(I,i){var F=I.formatter;I.mode=a.OneTime;if(F&&F.requiresIContext===true){I.formatter=F.bind(null,d(w,S,i));}}try{h(o);if(o.parts){o.parts.forEach(h);}w.bindProperty("any",o);return w.getBinding("any")?w.getAny():u;}finally{w.unbindProperty("any",true);}}function e(E,L){return E.namespaceURI===N&&l(E)===L;}function l(n){return n.localName||n.baseName;}function r(E){var m=E.getAttribute("template:require");if(m){q.sap.require.apply(q.sap,m.split(" "));}}function f(E){var A,o=E.attributes,t="<"+E.nodeName,i,n;for(i=0,n=o.length;i<n;i+=1){A=o.item(i);t+=" "+A.name+'="'+A.value+'"';}return t+(E.childNodes.length?">":"/>");}return{process:function(o,v,S){var h=v.caller,j=q.sap.log.isLoggable(q.sap.log.Level.DEBUG),k=j,m=v.name,F={},t=0,w,y={},z=q.sap.log.isLoggable(q.sap.log.Level.WARNING);function A(i){if(j){q.sap.log.debug(I()+Array.prototype.slice.call(arguments,1).join(" "),i&&f(i),x);}}function E(i){if(j){q.sap.log.debug(I()+"Finished","</"+i.nodeName+">",x);}}function G(i,n){i=i+f(n);q.sap.log.error(i,h,x);throw new Error(h+": "+i);}function H(e1){var f1=e1.childNodes,g1,h1=[],i,n,i1=false;for(i=0,n=f1.length;i<n;i+=1){g1=f1.item(i);if(g1.nodeType===1){h1.push(g1);}}if(!h1.length||!e(h1[0],"then")){return null;}for(i=1,n=h1.length;i<n;i+=1){g1=h1[i];if(i1){G("Expected </"+e1.prefix+":if>, but instead saw ",g1);}if(e(g1,"else")){i1=true;}else if(!e(g1,"elseif")){G("Expected <"+e1.prefix+":elseif> or <"+e1.prefix+":else>, but instead saw ",h1[i]);}}return h1;}function I(){return(t<10?"[ ":"[")+t+"] ";}function J(w){return w&&w.charAt(0)==="."?q.sap.getObject(w.slice(1),undefined,y):q.sap.getObject(w);}function K(i,n,e1,f1,g1){var h1;q.sap.measure.average(s,"",p);h1=B.complexParser(i,y,f1,true,true)||i;if(h1.functionsNotFound){if(f1){d1(n,'Function name(s)',h1.functionsNotFound.join(", "),'not found');}q.sap.measure.end(s);return u;}if(typeof h1==="object"){h1=g(e1,h1,S);if(f1&&h1===u){d1(n,'Binding not ready');}}else if(g1){g1();}q.sap.measure.end(s);return h1;}function L(i,n,e1){var f1,g1=m;e1.$mFragmentContexts=e1.$mFragmentContexts||{};if(e1.$mFragmentContexts[i]){G("Cyclic reference to fragment '"+i+"' ",n);}t++;A(n,"fragmentName =",i);e1.$mFragmentContexts[i]=true;m=i;q.sap.measure.average(P,"",p);f1=F[i];if(!f1){f1=X.loadTemplate(i,"fragment");F[i]=f1;}f1=n.ownerDocument.importNode(f1,true);q.sap.measure.end(P);r(f1);if(f1.namespaceURI==="sap.ui.core"&&l(f1)==="FragmentDefinition"){O(f1,e1,n);}else{n.parentNode.insertBefore(f1,n);c1(f1,e1);}n.parentNode.removeChild(n);m=g1;e1.$mFragmentContexts[i]=false;E(n);t--;}function O(i,n,e1){var f1;e1=e1||i;b1(i,n);while((f1=i.firstChild)){e1.parentNode.insertBefore(f1,e1);}}function Q(i,n){var e1=d1.bind(null,i,'Constant test condition'),f1,g1=i.getAttribute("test"),h1;try{h1=K(g1,i,n,true,e1);if(h1===u){h1=false;}}catch(ex){d1(i,'Error in formatter:',ex);h1=undefined;}f1=!!h1&&h1!=="false";if(j){if(typeof h1==="string"){h1=JSON.stringify(h1);}else if(h1===undefined){h1="undefined";}else if(Array.isArray(h1)){h1="[object Array]";}A(i,"test ==",h1,"-->",f1);}return f1;}function T(i,n,e1){var f1=n.value,g1;try{g1=K(f1,i,e1,false);if(g1===u){A(i,'Binding not ready for attribute',n.name);}else if(g1===undefined){A(i,"Removed attribute",n.name);i.removeAttribute(n.name);}else{if(j&&g1!==n.value){A(i,n.name,"=",g1);}n.value=g1;}}catch(ex){A(i,'Error in formatter:',ex);}}function U(i,n){var w=i.getAttribute("name"),e1,f1,g1=i.getAttribute("value");if(!w||w.length<=1||w.lastIndexOf(".")!==0){G("Missing proper relative name in ",i);}w=w.slice(1);e1=J(g1);if(!e1){G("Invalid value in ",i);}f1=y[w];y[w]=e1;O(i,n);i.parentNode.removeChild(i);y[w]=f1;}function V(i,n){var w=i.getAttribute("name"),e1=u,f1;try{e1=K(w,i,n,true);if(e1!==u&&e1!==w){A(i,"name =",e1);}}catch(ex){d1(i,'Error in formatter:',ex);}if(e1!==u&&sap.ui.core.CustomizingConfiguration){f1=sap.ui.core.CustomizingConfiguration.getViewExtension(m,e1,v.componentId);if(f1&&f1.className==="sap.ui.core.Fragment"&&f1.type==="XML"){L(f1.fragmentName,i,n);return true;}}return false;}function Y(i,n){var e1=i.getAttribute("fragmentName"),f1;try{f1=K(e1,i,n,true);}catch(ex){d1(i,'Error in formatter:',ex);return;}if(f1!==u){L(f1,i,n);}}function Z(i,n){var e1=H(i),f1,g1;t++;if(e1){g1=i;f1=e1.shift();do{if(Q(g1,n)){break;}g1=f1=e1.shift();}while(g1&&l(g1)==="elseif");}else if(Q(i,n)){f1=i;}if(f1){O(f1,n,i);}i.parentNode.removeChild(i);E(i);t--;}function $(n,e1){var f1=n.getAttribute("list")||"",g1=B.complexParser(f1,y,false,true,true),h1,i1,j1,k1,l1=n.getAttribute("var");if(l1===""){G("Missing variable name for ",n);}if(!g1){G("Missing binding for ",n);}if(g1.functionsNotFound){d1(n,'Function name(s)',g1.functionsNotFound.join(", "),'not found');}k1=new R();e1.setChild(k1);g1.mode=a.OneTime;k1.bindAggregation("list",g1);i1=k1.getBinding("list");k1.unbindAggregation("list",true);j1=g1.model;if(!i1){G("Missing model '"+j1+"' in ",n);}h1=i1.getContexts(g1.startIndex,g1.length);l1=l1||j1;k1.setModel(i1.getModel(),l1);t++;A(n,"Starting");h1.forEach(function(m1,i){var n1=(i===h1.length-1)?n:n.cloneNode(true);k1.setBindingContext(m1,l1);A(n,l1,"=",m1.getPath());O(n1,k1,n);});E(n);t--;n.parentNode.removeChild(n);}function _(i,n){var e1,f1,g1,h1,i1=i.getAttribute("helper"),j1,k1=i.getAttribute("path"),l1,m1=i.getAttribute("var");if(m1===""){G("Missing variable name for ",i);}g1=new W();n.setChild(g1);e1=B.simpleParser("{"+k1+"}");m1=m1||e1.model;if(i1||m1){f1=n.getModel(e1.model);if(!f1){G("Missing model '"+e1.model+"' in ",i);}l1=f1.resolve(e1.path,n.getBindingContext(e1.model));if(!l1){G("Cannot resolve path for ",i);}if(i1){h1=J(i1);if(typeof h1!=="function"){G("Cannot resolve helper for ",i);}j1=h1(f1.createBindingContext(l1));if(j1 instanceof b){f1=j1.getModel();l1=j1.getPath();}else if(j1!==undefined){if(typeof j1!=="string"||j1===""){G("Illegal helper result '"+j1+"' in ",i);}l1=j1;}}g1.setModel(f1,m1);g1.bindObject({model:m1,path:l1});}else{g1.bindObject(k1);}t++;A(i,m1,"=",l1);if(g1.getBindingContext(m1)===n.getBindingContext(m1)){d1(i,'Set unchanged path:',l1);g1=n;}O(i,g1);i.parentNode.removeChild(i);E(i);t--;}function a1(n,e1){var i,f1=n.attributes;for(i=f1.length-1;i>=0;i-=1){T(n,f1.item(i),e1);}}function b1(e1,f1){var i,g1=e1.childNodes,n=g1.length,h1=new Array(n);for(i=0;i<n;i+=1){h1[i]=g1.item(i);}g1=null;for(i=0;i<n;i+=1){c1(h1[i],f1);}}function c1(n,i){if(n.nodeType!==1){return;}if(n.namespaceURI===N){switch(l(n)){case"alias":U(n,i);return;case"if":Z(n,i);return;case"repeat":$(n,i);return;case"with":_(n,i);return;default:G("Unexpected tag ",n);}}else if(n.namespaceURI==="sap.ui.core"){switch(l(n)){case"ExtensionPoint":if(V(n,i)){return;}break;case"Fragment":if(n.getAttribute("type")==="XML"){Y(n,i);return;}break;}}a1(n,i);b1(n,i);}function d1(i){if(z){if(!k){k=true;q.sap.log.warning("Warning(s) during processing of "+h,null,x);}q.sap.log.warning(I()+Array.prototype.slice.call(arguments,1).join(" "),i&&f(i),x);}}q.sap.measure.average(c,"",p);S=S||{};if(j){A(undefined,"Start processing",h);if(S.bindingContexts instanceof b){A(undefined,"undefined =",S.bindingContexts);}else{for(w in S.bindingContexts){A(undefined,w,"=",S.bindingContexts[w]);}}}r(o);c1(o,new W({models:S.models,bindingContexts:S.bindingContexts}));A(undefined,"Finished processing",h);q.sap.measure.end(c);return o;}};},true);
