/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global'],function(q){"use strict";var F=function(){this._oFeedbackContextText;this._oIncludeFeedbackContextCB;};F.prototype.updateFeedbackContextText=function(){if(this._oIncludeFeedbackContextCB.getChecked()){u.call(this);}else{a.call(this);}function u(){this._oFeedbackContextText.setText("Location: "+this._getCurrentPageRelativeURL()+"\n"+this._getUI5Distribution()+" Version: "+sap.ui.getVersionInfo().version);}function a(){this._oFeedbackContextText.setText(this._getUI5Distribution()+" Version: "+sap.ui.getVersionInfo().version);}};F.prototype._getUI5Distribution=function(){var v=sap.ui.getVersionInfo();var u="SAPUI5";if(v&&v.gav&&/openui5/i.test(v.gav)){u="OpenUI5";}return u;};F.prototype._getCurrentPageRelativeURL=function(){var p=window.location;return p.pathname+p.hash+p.search;};F.prototype.createFeedbackPopup=function(){this._oFeedbackContextText=new sap.ui.commons.TextView("oFeedbackContextText");this._oIncludeFeedbackContextCB=new sap.ui.commons.CheckBox("includePageCB");var t=this;var c=q.sap.loadResource('sap/ui/demokit/configuration/properties.json');var f=c["FeedbackServiceURL"];var a='Describe what you like or what needs to be improved. You can share your feedback for the overall Demokit experience or for the specific page you are currently viewing.';var o,r,b,d,C,e,s;function g(L){i();L.addContent(e);x.removeAllContent();x.addContent(L);}function h(){x.setBusyIndicatorDelay(0);x.setBusy(true);d.setValueState(sap.ui.core.ValueState.None);d.setPlaceholder(a);}function i(){x.setBusy(false);o.setText("");b.setSelectedButton();d.setValue('');t._oIncludeFeedbackContextCB.setChecked(false);t._oIncludeFeedbackContextCB.fireChange();t._oFeedbackContextText.setVisible(false);C.setText("Show context data");C.setTooltip("Show context data");s.setEnabled(false);}function j(){sap.ui.core.IconPool.addIcon("icon-face-very-bad","FeedbackRatingFaces",{fontFamily:"FeedbackRatingFaces",content:"E086",suppressMirroring:true});sap.ui.core.IconPool.addIcon("icon-face-bad","FeedbackRatingFaces",{fontFamily:"FeedbackRatingFaces",content:"E087",suppressMirroring:true});sap.ui.core.IconPool.addIcon("icon-face-neutral","FeedbackRatingFaces",{fontFamily:"FeedbackRatingFaces",content:"E089",suppressMirroring:true});sap.ui.core.IconPool.addIcon("icon-face-happy","FeedbackRatingFaces",{fontFamily:"FeedbackRatingFaces",content:"E08B",suppressMirroring:true});sap.ui.core.IconPool.addIcon("icon-face-very-happy","FeedbackRatingFaces",{fontFamily:"FeedbackRatingFaces",content:"E08C",suppressMirroring:true});}function k(){var R=new sap.ui.commons.FormattedTextView("feedbackRateYourExperienceLabel");R.setHtmlText("<span class='feedbackAsterisk'>*</span>Rate your experience:");o=new sap.ui.commons.Label("feedbackRatingLabel",{});return new sap.ui.layout.HorizontalLayout('feedbackRatingHeader',{content:[R,o]});}function l(){j();b=new sap.ui.commons.SegmentedButton({id:"feedbackRatingButton",buttons:[y("icon-face-very-bad","Very Poor",1),y("icon-face-bad","Poor",2),y("icon-face-neutral","Average",3),y("icon-face-happy","Good",4),y("icon-face-very-happy","Excellent",5)]});function y(A,L,V){var B="sap-icon://FeedbackRatingFaces/"+A;return new sap.ui.commons.Button({icon:B,width:"20%",press:z.bind(this,L,V)});}function z(L,V){o.setText(L);r=V;s.setEnabled(true);}return b;}function m(){d=new sap.ui.commons.TextArea("demokitFeedbackInput",{rows:13});d.setPlaceholder(a);return d;}function n(){t._oIncludeFeedbackContextCB.setText('Feedback is related to the current page');t._oIncludeFeedbackContextCB.attachChange(t.updateFeedbackContextText.bind(t));C=new sap.ui.commons.Link("feedbackContextDataLink",{wrapping:"false",text:"Show context data",tooltip:"Show context data",press:function(){if(t._oFeedbackContextText.getVisible()===false){C.setText("Hide context data");C.setTooltip("Hide context data");t._oFeedbackContextText.setVisible(true);}else{C.setText("Show context data");C.setTooltip("Show context data");t._oFeedbackContextText.setVisible(false);}}});return new sap.ui.layout.HorizontalLayout("feedbackContextButtons",{content:[t._oIncludeFeedbackContextCB,C]});}function p(){t._oFeedbackContextText.addStyleClass("feedbackContextData");t._oFeedbackContextText.setVisible(false);t.updateFeedbackContextText();return t._oFeedbackContextText;}function u(){var L=new sap.ui.commons.Link({text:"Privacy",tooltip:"Privacy",target:"_blank",href:"https://help.hana.ondemand.com/privacy.htm"});var y=new sap.ui.commons.Link({text:"Terms of Use",tooltip:"Terms of Use",target:"_blank",href:"https://help.hana.ondemand.com/terms_of_use.html"});var z=new sap.ui.commons.Link({text:"Legal Agreement",tooltip:"Legal Agreement",target:"_blank",href:"./legal_agreement_with_privacy.html"});var A=new sap.ui.commons.FormattedTextView();var B='Your feedback is anonymous, we do not collect any personal data. For more information see <embed data-index=\"0\">, <embed data-index=\"1\"> & <embed data-index=\"2\">.';A.addStyleClass("feedbackLicenseText");A.setHtmlText(B);A.addControl(L);A.addControl(y);A.addControl(z);return A;}function v(){var y=new sap.ui.commons.Button({text:"Cancel",tooltip:"Cancel",press:function(){i();x.close();}});e=new sap.ui.commons.Button('closeBtn',{text:"Close",tooltip:"Close",press:function(){x.close();}});s=new sap.ui.commons.Button('sendBtn',{text:"Send",tooltip:"Send feedback",enabled:false,press:function(){var B={};if(t._oIncludeFeedbackContextCB.getChecked()){B={"texts":{"t1":d.getValue()},"ratings":{"r1":{"value":r}},"context":{"page":t._getCurrentPageRelativeURL(),"attr1":t._getUI5Distribution()+":"+sap.ui.version}};}else{B={"texts":{"t1":d.getValue()},"ratings":{"r1":{"value":r}},"context":{"attr1":t._getUI5Distribution()+":"+sap.ui.version}};}h();q.ajax({url:f,type:"POST",contentType:"application/json",data:JSON.stringify(B)}).done(function(){g(z);}).fail(function(){g(A);});}});var z=new sap.ui.layout.VerticalLayout({content:[new sap.ui.commons.FormattedTextView('successMsg',{htmlText:'<h4>Your feedback was sent successfully.</h4>'})]});var A=new sap.ui.layout.VerticalLayout({content:[new sap.ui.commons.FormattedTextView('errorMsg',{htmlText:'<h4>Your feedback was not sent.</h4>'})]});return new sap.ui.layout.HorizontalLayout('feedbackButtons',{content:[s,y]});}var w=new sap.ui.layout.form.SimpleForm({maxContainerCols:1,width:'400px',editable:true,layout:sap.ui.layout.form.SimpleFormLayout.ResponsiveGridLayout,content:[new sap.ui.commons.Label({text:'Send us your feedback!'}),k(),l(),m(),n(),p(),u(),v()]});var I="theme/img/themeswitch_";var x=new sap.ui.ux3.ToolPopup('feedBackPopup',{icon:'sap-icon://comment',iconHover:I+'hover.png',iconSelected:I+'selected.png',content:[w],defaultButton:s,closed:function(){this.removeAllContent();this.addContent(w);}});x.setTooltip("Send us your feedback!");return x;};return F;},true);
