/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/base/ManagedObjectMetadata','./ASTUtils','./Doclet','sap/ui/demokit/js/esprima'],function(q,M,A,D,e){"use strict";var S=esprima.Syntax;var c;var I;var p;var C;var s;function g(n){if(n.type===S.MemberExpression){var i=g(n.object);return i?i+"."+n.property.name:null;}else if(n.type===S.Identifier){return s[n.name]?s[n.name]:n.name;}else{return null;}}function a(n){return(n.type==S.CallExpression&&n.callee.type==S.MemberExpression&&g(n.callee)=="sap.ui.define");}function b(n){return(n.type==S.CallExpression&&n.callee.type==S.MemberExpression&&n.callee.property.type==S.Identifier&&n.callee.property.name=='extend'&&n.arguments.length>=2&&n.arguments[0].type==S.Literal&&typeof n.arguments[0].value=="string"&&A.unlend(n.arguments[1]).type==S.ObjectExpression);}function r(i){return/^\.\//.test(i)?c+i.slice(1):i;}function d(P,j){var n='',B='',E,F,G=/{(.*)}/,H;for(var i=0;i<j.length;i++){if(j[i].tag!=='param'){continue;}H=G.exec(j[i].content);E=j[i].content.indexOf(P);if(H&&E>-1){n=H[1];F=E+P.length;B=j[i].content.substr(F);B=B.replace(/[-]/,'').trim();break;}}return{name:P,type:n,doc:B};}function f(i){i.methods=p;}var h=A.createPropertyMap;var u=A.unlend;var k=M._guessSingularName;var l=D.get;var m=q.sap.log.error;var w=q.sap.log.warning;var v=q.sap.log.debug;function o(i,j){var B=g(i.callee.object);var E={metatype:'control',name:i.arguments[0].value,baseType:B,doc:j&&(j.classdesc||j.description),deprecation:j&&j.deprecated,since:j&&j.since,experimental:j&&j.experimental,properties:{},aggregations:{},associations:{},events:{},methods:{}};function F(K,L,N){var O,n,P,Q;O=K&&h(K.value);if(O){for(n in O){if(O.hasOwnProperty(n)){Q=l(O[n]);P=h(O[n].value,L);if(P==null){m("no valid metadata for "+n+" (AST type '"+O[n].value.type+"')");continue;}N(n,P,Q,O[n]);}}}}var G=u(i.arguments[1]);var H=h(G);if(H&&H.metadata&&H.metadata.value.type!==S.ObjectExpression){w("class metadata exists but can't be analyzed. It is not of type 'ObjectExpression', but a '"+H.metadata.value.type+"'.");return null;}var J=H&&H.metadata&&h(H.metadata.value);if(J){v("  analyzing metadata for '"+E.name+"'");E["abstract"]=!!(J["abstract"]&&J["abstract"].value.value);E["final"]=!!(J["final"]&&J["final"].value.value);F(J.properties,"type",function(n,K,L){E.properties[n]={name:n,doc:L&&L.description,since:L&&L.since,deprecation:L&&L.deprecated,experimental:L&&L.experimental,visibility:(K.visibility&&K.visibility.value.value)||"public",type:K.type?K.type.value.value:"string",defaultValue:(K.defaultValue&&K.defaultValue.value.value!==null)?K.defaultValue.value.value:undefined,bindable:K.bindable?K.bindable.value.value==="bindable":false};});E.defaultAggregation=(J.defaultAggregation&&J.defaultAggregation.value.value)||undefined;F(J.aggregations,"type",function(n,K,L){E.aggregations[n]={name:n,doc:L&&L.description,deprecation:L&&L.deprecated,since:L&&L.since,experimental:L&&L.experimental,visibility:(K.visibility&&K.visibility.value.value)||"public",type:K.type?K.type.value.value:"sap.ui.core.Control",singularName:K.singularName?K.singularName.value.value:k(n),cardinality:(K.multiple&&!K.multiple.value.value)?"0..1":"0..n",bindable:K.bindable?K.bindable.value.value==="bindable":false};});F(J.associations,"type",function(n,K,L){E.associations[n]={name:n,doc:L&&L.description,deprecation:L&&L.deprecated,since:L&&L.since,experimental:L&&L.experimental,visibility:(K.visibility&&K.visibility.value.value)||"public",type:K.type?K.type.value.value:"sap.ui.core.Control",singularName:K.singularName?K.singularName.value.value:k(n),cardinality:(K.multiple&&K.multiple.value.value)?"0..n":"0..1"};});F(J.events,null,function(n,K,L){var N=E.events[n]={name:n,doc:L&&L.description,deprecation:L&&L.deprecated,since:L&&L.since,experimental:L&&L.experimental,allowPreventDefault:!!(K.allowPreventDefault&&K.allowPreventDefault.value.value),parameters:{}};F(K.parameters,null,function(O,P,Q){N.parameters[O]={name:O,doc:Q&&Q.description,deprecation:Q&&Q.deprecated,since:Q&&Q.since,experimental:Q&&Q.experimental,type:P&&P.type?P.type.value.value:""};});});}return E;}function t(n){var j=D.get(n);var B=g(n.expression.left);if(B&&j&&j.isPublic()){var T={metatype:"type",doc:undefined,deprecation:false,visibility:'public'};T.name=B;if(j){T.doc=j.description;T.deprecation=j.deprecation;T.since=j.since;T.experimental=j.experimental;}var E=n.expression.right.properties||[];T.values={};for(var i=0;i<E.length;i++){var F=D.get(E[i]);var G=E[i].key;var H=E[i].value;var J={};if(G.type==S.Identifier){J.name=G.name;}else if(G.type==S.Literal){J.name=G.value;}else{throw new Error();}if(H.type==S.Literal){J.value=H.value;}else{throw new Error();}if(F!=null){J.doc=F.description;J.deprecation=F.deprecation;J.since=F.since;J.experimental=F.experimental;}T.values[J.name]=J;}I.push(T);}}function x(n){var i=D.get(n);var j=n.expression.right.arguments[0].value;var B=A.createPropertyMap(n.expression.right.arguments[1]);var E=null;if(n.expression.right.arguments.length>2&&n.expression.right.arguments[2].type==S.CallExpression&&n.expression.right.arguments[2].callee.type==S.MemberExpression&&g(n.expression.right.arguments[2].callee)=="sap.ui.base.DataType.getType"&&n.expression.right.arguments[2].arguments.length>0&&n.expression.right.arguments[2].arguments[0].type==S.Literal){E=n.expression.right.arguments[2].arguments[0].value;}if(j&&i&&i.isPublic()){var T={metatype:"type",doc:undefined,deprecation:false,visibility:'public'};T.name=j;if(i){T.doc=i.description;T.deprecation=i.deprecation;T.since=i.since;T.experimental=i.experimental;}var F=B.defaultValue;if(F){T.defaultValue=F.value.value;}var G=B.isValid;if(G&&G.value.type==S.FunctionExpression&&G.value.body&&G.value.body.body.length>0&&G.value.body.body[0].type==S.ReturnStatement&&G.value.body.body[0].argument.type==S.CallExpression&&G.value.body.body[0].argument.callee.type==S.MemberExpression&&G.value.body.body[0].argument.callee.object.type==S.Literal&&G.value.body.body[0].argument.callee.object.value instanceof RegExp){var H=G.value.body.body[0].argument.callee.object.value.source;if(/^\^\(.*\)\$$/.test(H)){H=H.slice(2,-2);}T.pattern=H;}T.baseType=E;I.push(T);}}var y={"ExpressionStatement":function(n){if(a(n.expression)){var i=0;var B,E;if(i<n.expression.arguments.length&&n.expression.arguments[i].type===S.Literal){n.expression.arguments[i++].value;}if(i<n.expression.arguments.length&&n.expression.arguments[i].type===S.ArrayExpression){B=n.expression.arguments[i++].elements;}if(i<n.expression.arguments.length&&n.expression.arguments[i].type===S.FunctionExpression){E=n.expression.arguments[i++];}if(B&&E&&E.params){for(var j=0;j<B.length;j++){var F=B[j].type===S.Literal?r(B[j].value):null;var G=j<E.params.length?E.params[j].name:null;if(F&&G){s[G]=F.replace(/\//g,'.');}}}}if(n.expression.type==S.AssignmentExpression&&n.expression.right.type==S.ObjectExpression&&n.expression.left.type==S.MemberExpression){t(n);}if(n.expression.type===S.AssignmentExpression&&n.expression.right.type===S.CallExpression&&n.expression.right.callee.type===S.MemberExpression&&n.expression.right.callee.property.type===S.Identifier&&n.expression.right.callee.property.name==='createType'&&g(n.expression.right.callee.object)=='sap.ui.base.DataType'&&n.expression.right.arguments.length>=2&&n.expression.right.arguments[0].type===S.Literal&&n.expression.right.arguments[1].type===S.ObjectExpression){x(n);}if(b(n.expression)){var H=D.get(n)||D.get(n.expression);var J=o(n.expression,H);if(J){I.push(J);}}},"VariableDeclaration":function(n){if(n.declarations.length==1&&n.declarations[0].init&&b(n.declarations[0].init)){var i=D.get(n)||D.get(n.declarations[0]);var j=o(n.declarations[0].init,i);if(j){I.push(j);}}},"FunctionExpression":function(n){var F=n.body.body;F.forEach(function(i){if(i.expression&&i.expression.type!==S.AssignmentExpression){return;}var P=i;var j=D.get(i);if(j&&j.isPublic()&&P.expression&&P.expression.left&&P.expression.left.property&&P.expression.left.object&&P.expression.left.object.object&&P.expression.left.object.object.name===C){var B={},E=P.expression.right.params?P.expression.right.params:[];B.name=P.expression.left.property.name;B.doc=j.description;B.since=j.since;B.experimental=j.experimental;B.deprecation=j.deprecated;B.type=j.type?j.type:'';B.parameters=[];E.forEach(function(G){var H=d(G.name,j.tags);B.parameters.push(H);});p[B.name]=B;}});}};function z(j,E,n){c=n.split('/').slice(0,-1).join('/');I=[];p={};s={};C=E.split('.').pop();var B=esprima.parse(j,{comment:true,attachComment:true});A.visit(B,y);for(var i=0;i<I.length;i++){if(I[i].name===E){f(I[i]);return I[i];}}}return{analyze:z};},false);
