/*
 * ! UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/base/ManagedObject','sap/ui/dt/ElementUtil','sap/ui/dt/OverlayUtil'],function(M,E,O){"use strict";var a=M.extend("sap.ui.dt.plugin.ElementMover",{metadata:{library:"sap.ui.dt",properties:{movableTypes:{type:"string[]",defaultValue:["sap.ui.core.Element"]}},associations:{},events:{}}});a.prototype._getMovableTypes=function(){return this.getProperty("movableTypes")||[];};a.prototype.isMovableType=function(e){var m=this._getMovableTypes();return m.some(function(t){return E.isInstanceOf(e,t);});};a.prototype.checkMovable=function(o){return true;};a.prototype.getMovedOverlay=function(){return this._oMovedOverlay;};a.prototype.setMovedOverlay=function(m){if(m){this._source=O.getParentInformation(m);}else{delete this._source;}this._oMovedOverlay=m;};a.prototype._getSource=function(){return this._source;};a.prototype.activateAllValidTargetZones=function(d,A){this._iterateAllAggregations(d,this._activateValidTargetZone.bind(this),A);};a.prototype._activateValidTargetZone=function(A,s){if(this.checkTargetZone(A)){A.setTargetZone(true);if(s){A.addStyleClass(s);}}};a.prototype.checkTargetZone=function(A){if(!A.$().is(":visible")){return false;}var p=A.getElementInstance();var m=this.getMovedOverlay().getElementInstance();var s=A.getAggregationName();if(E.isValidForAggregation(p,s,m)){return true;}};a.prototype._deactivateTargetZone=function(A,s){A.setTargetZone(false);if(s){A.removeStyleClass(s);}};a.prototype.activateTargetZonesFor=function(o,A){this._iterateOverlayAggregations(o,this._activateValidTargetZone.bind(this),A);};a.prototype.deactivateTargetZonesFor=function(o,A){this._iterateOverlayAggregations(o,this._deactivateTargetZone.bind(this),A);};a.prototype.deactivateAllTargetZones=function(d,A){this._iterateAllAggregations(d,this._deactivateTargetZone.bind(this),A);};a.prototype._iterateAllAggregations=function(d,s,A){var t=this;var o=d.getElementOverlays();o.forEach(function(b){t._iterateOverlayAggregations(b,s,A);});};a.prototype._iterateOverlayAggregations=function(o,s,A){var b=o.getAggregationOverlays();b.forEach(function(c){s(c,A);});};a.prototype.repositionOn=function(m,t){var o=m.getElementInstance();var T=O.getParentInformation(t);if(T.index!==-1){E.insertAggregation(T.parent,T.aggregation,o,T.index);}};a.prototype.insertInto=function(m,t){var o=m.getElementInstance();var T=t.getElementInstance();var s=m.getParent();if(t!==s){var b=t.getAggregationName();E.addAggregation(T,b,o);}};a.prototype.buildMoveEvent=function(){var m=this.getMovedOverlay();var o=m.getElementInstance();return{element:o,source:this._getSource(),target:O.getParentInformation(m)};};return a;},true);
