/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define('sap/ui/qunit/QUnitUtils',['jquery.sap.global','sap/ui/Device','sap/ui/base/DataType'],function(q,D,f){"use strict";if(typeof QUnit!=='undefined'){var p=q.sap.getUriParameters();QUnit.equals=window.equals=window.equal;var t=p.get("sap-ui-qunittimeout");if(!t||isNaN(t)){t="30000";}QUnit.config.testTimeout=parseInt(t,10);QUnit.config.reorder=false;if(window["sap-ui-qunit-coverage"]!=="client"&&/x|true/i.test(q.sap.getUriParameters().get("coverage-report"))){QUnit.done(function(a,b){if(window._$blanket&&document.addEventListener){var c=window.QUnit;window.QUnit=undefined;q.sap.require("sap.ui.thirdparty.blanket");window.QUnit=c;window.blanket.report({});}});}if(D.browser.internet_explorer&&D.browser.version==9){QUnit.begin(function(){if(window.sinon&&window.sinon.xhr){window.sinon.xhr.supportsCORS=true;}});}}if(D.browser.phantomJS){var $=q.fn.is;q.fn.is=function(s){if(s===":focus"){return this.get(0)===document.activeElement;}return $.apply(this,arguments);};}if(D.browser.phantomJS){var g=Date,h=g.parse;Date=function(d){if(arguments.length===1&&typeof d==='string'){return new g(Date.parse(d));}var a=Array.prototype.slice.call(arguments);a.unshift(window);if(this instanceof g){return new(Function.prototype.bind.apply(g,a));}else{return g.apply(window,a);}};var k=function(d){var M=h.apply(Date,arguments);if(d&&typeof d==="string"){var m=/^(\d{4})(?:-(\d+)?-(\d+))(?:[T ](\d+):(\d+)(?::(\d+)(?:\.(\d+))?)?)?(?:Z(-?\d*))?$/.exec(d);if(m&&parseInt(m[1],10)>=2034){M+=24*60*60*1000;}}return M;};Object.defineProperties(Date,{"parse":{value:k,enumerable:false},"toString":{value:function(){return g.toString.call(this);},enumerable:false},"now":{value:g.now,enumerable:false},"UTC":{value:g.UTC,enumerable:false},"prototype":{value:g.prototype,enumerable:false}});}var Q={};Q.delayTestStart=function(d){QUnit.config.autostart=false;if(d){window.setTimeout(function(){QUnit.start();},d);}else{q(function(){QUnit.start();});}};Q.triggerEvent=function(e,T,P){var a=q.Event(e);a.originalEvent=a.originalEvent||{};if(P){for(var x in P){a[x]=P[x];a.originalEvent[x]=P[x];}}if(typeof(T)=="string"){T=q.sap.domById(T);}q(T).trigger(a);};Q.triggerTouchEvent=function(e,T,P){if(typeof(T)=="string"){T=q.sap.domById(T);}var a=q(T);var E=q.Event(e);E.originalEvent={};E.target=T;if(P){for(var x in P){E[x]=P[x];E.originalEvent[x]=P[x];}}var o=a.control(0);if(o&&o["on"+e]){o["on"+e].apply(o,[E]);}};Q.triggerKeyEvent=function(e,T,K,s,a,c){var P={};P.keyCode=isNaN(K)?q.sap.KeyCodes[K]:K;P.which=P.keyCode;P.shiftKey=s;P.altKey=a;P.metaKey=c;P.ctrlKey=c;Q.triggerEvent(e,T,P);};Q.triggerKeydown=function(T,K,s,a,c){Q.triggerKeyEvent("keydown",T,K,s,a,c);};Q.triggerKeyup=function(T,K,s,a,c){Q.triggerKeyEvent("keyup",T,K,s,a,c);};Q.triggerKeyboardEvent=function(T,K,s,a,c){Q.triggerKeydown(T,K,s,a,c);};Q.triggerKeypress=function(T,c,s,a,C){var _=c&&c.toUpperCase();if(q.sap.KeyCodes[_]===null){QUnit.ok(false,"Invalid character for triggerKeypress: '"+c+"'");}var b=c.charCodeAt(0);var P={};P.charCode=b;P.which=b;P.shiftKey=!!s;P.altKey=!!a;P.metaKey=!!C;P.ctrlKey=!!C;Q.triggerEvent("keypress",T,P);};Q.triggerCharacterInput=function(i,c){Q.triggerKeypress(i,c);if(typeof(i)=="string"){i=q.sap.domById(i);}var I=q(i);I.val(I.val()+c);};Q.triggerMouseEvent=function(T,e,o,O,P,i,b){var a={};a.offsetX=o;a.offsetY=O;a.pageX=P;a.pageY=i;a.button=b;Q.triggerEvent(e,T,a);};var F={'normal':400,'bold':700};q.fn.extend({_sapTest_dataEvents:function(){var e=this[0];return e?q._data(e,"events"):null;},_sapTest_cssFontWeight:function(){var v=this.css("font-weight");return v?F[v]||v:v;}});(function(){function m(a){q.sap.log.info(a);}var M={"boolean":[false,true],"int":[0,1,5,10,100],"float":[NaN,0.0,0.01,3.14,97.7],"string":["","some","very long otherwise not normal and so on whatever","<"+"script>alert('XSS attack!');</"+"script>"]};var u=q.sap.newObject(M);function v(o){return o&&!(o instanceof Array)?[o]:o;}Q.resetDefaultTestValues=function(T){if(typeof T==="string"){delete u[T];}else{u=q.sap.newObject(M);}};Q.setDefaultTestValues=function(T,V){if(typeof T==="string"){u[T]=v(V);}else if(typeof T==="object"){q.extend(u,T);}};Q.createSettingsDomain=function(c,P){function a(T){if(u[T]){return u[T];}try{q.sap.require(T);}catch(e){}var i=q.sap.getObject(T);if(!(i instanceof f)){var r=[];for(var n in i){r.push(i[n]);}u[T]=r;return r;}return[];}var c=new c().getMetadata().getClass();var P=P||{};var b={};var o=c.getMetadata().getAllProperties();for(var d in o){b[d]=v(P[d])||a(o[d].type);}return b;};Q.genericTest=function(c,U,T){if(T&&T.skip===true){return;}var c=new c().getMetadata().getClass();var T=T||{};var o=Q.createSettingsDomain(c,T.allPairTestValues||{});m("domain");for(var n in o){var l=o[n].length;var s=[];s.push("  ",n,":","[");for(var i=0;i<l;i++){s.push(o[n][i],",");}s.push("]");m(s.join(""));}function a(P,N){return P+N.substring(0,1).toUpperCase()+N.substring(1);}function b(C,S){var A={};for(var r in S){if(C[a("get",r)]){A[r]=C[a("get",r)]();}}return A;}var C;var S;var d=new Q.AllPairsGenerator(o);var e=[];while(d.hasNext()){e.push(d.next());}var j=0;function w(){m("testNextCombination("+j+")");if(j>=e.length){m("last combination -> done");QUnit.start();return;}C=new c(S);var A=b(C,S);QUnit.deepEqual(A,S,"settings");C.placeAt(U);m("before explicit rerender");C.getUIArea().rerender();m("after explicit rerender");m("info");setTimeout(x,0);}QUnit.stop(15000);w();function x(){m("continueAfterRendering("+j+")");var y=e[e.length-j-1];for(var z in y){var r=C[a("set",z)](y[z]);QUnit.equal(C[a("get",z)](),y[z],"setter for property '"+z+"'");QUnit.ok(r==C,"setter for property '"+z+"' supports chaining (after rendering)");}j=j+1;setTimeout(w,0);}};Q.suppressErrors=function(s){if(s!==false){m("suppress global errors");}else{m("reenable global errors");}};Q.RandomPairsGenerator=function(d){var C=0;for(var n in d){if(d[n]&&!(d[n]instanceof Array)){d[n]=[d[n]];}if(d[n]&&d[n].length>0){if(C==0){C=d[n].length;}else{C=C*d[n].length;}}}function a(i){var s={};for(var b in d){var l=d[b]&&d[b].length;if(l==1){s[b]=d[b][0];}else if(l>1){var c=i%l;s[b]=d[b][c];i=(i-c)/l;}}return s;}this.hasNext=function(){return true;};this.next=function(){return a(Math.floor(100*C*Math.random()));};};Q.AllPairsGenerator=function(o){var e=[];for(var n in o){e.push({name:n,n:o[n].length,values:o[n]});}var N=e.length;var l=[];var r=[];var s=0;for(var a=0;a<N-1;a++){var w=e[a];for(var b=a+1;b<N;b++){var x=e[b];r[a*N+b]=s;for(var i=w.n*x.n;i>0;i--){l[s++]=0;}}}function y(a,b,c,d){return r[a*N+b]+c*e[b].n+d;}function z(){var C=[];function E(a,I){var K={va:I,pairs:0,redundant:0};for(var c=0;c<N;c++){var L;if(c<a){L=l[y(c,a,C[c],I)];}else if(c>a){var j=y(a,c,I,0),O=j+e[c].n;for(L=l[j];L>0&&i<O;j++){if(l[j]<L){L=l[j];}}}K.redundant=K.redundant+L;if(L==0){K.pairs++;}}return K;}for(var d=0;d<N;d++){var G=e[d];var H=E(d,0);for(var I=1;I<G.n;I++){var J=E(d,I);if(J.pairs>H.pairs||(J.pairs==H.pairs&&J.redundant<H.redundant)){H=J;}}C[d]=H.va;}return C;}this.hasNext=function(){return s>0;};var A;var B=-1;this.next=function(){A=z();B=0;var c={};for(var a=0;a<N;a++){for(var b=a+1;b<N;b++){var i=y(a,b,A[a],A[b]);if(l[i]==0){s--;B++;}l[i]++;}c[e[a].name]=e[a].values[A[a]];}return c;};this.lastPairs=function(){return B;};};}());q.sap.setObject("sap.ui.test.qunit",Q);window.qutils=Q;return Q;},true);
