/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/core/date/UniversalDate'],function(q,U){"use strict";var C={};C.render=function(r,R){var t=R.getTooltip_AsString();r.write("<div");r.writeControlData(R);r.addClass("sapUiCalendarRow");if(R._sFocusedAppointmentId){r.writeAttribute("tabindex","-1");}else{r.writeAttribute("tabindex","0");}if(t){r.writeAttributeEscaped('title',t);}var w=R.getWidth();if(w){r.addStyle("width",w);}var h=R.getHeight();if(h){r.addStyle("height",h);}r.writeAccessibilityState(R);r.writeClasses();r.writeStyles();r.write(">");this.renderAppointmentsRow(r,R);r.write("</div>");};C.renderAppointmentsRow=function(r,R){r.write("<div id=\""+R.getId()+"-Apps\" class=\"sapUiCalendarRowApps\">");this.renderAppointments(r,R);r.write("</div>");};C.renderAppointments=function(r,R){var a=R._getVisibleAppointments();var I=R._getVisibleIntervalHeaders();var s=R._getStartDate();var n=[];var S=0;var N=0;var b=[];var c=0;var d=0;var e=R.getIntervals();var f=R.getIntervalType();var w=100/e;var i=0;switch(f){case sap.ui.unified.CalendarIntervalType.Hour:n=R.getNonWorkingHours()||[];S=s.getUTCHours();N=24;break;case sap.ui.unified.CalendarIntervalType.Day:n=R._getNonWorkingDays();S=s.getUTCDay();N=7;b=R.getNonWorkingHours()||[];c=s.getUTCHours();d=24;break;case sap.ui.unified.CalendarIntervalType.Month:b=R._getNonWorkingDays();c=s.getUTCDay();d=7;break;default:break;}for(i=0;i<e;i++){this.renderInterval(r,R,i,w,I,n,S,N,b,c,d);}r.write("<div id=\""+R.getId()+"-Now\" class=\"sapUiCalendarRowNow\"></div>");for(i=0;i<a.length;i++){var A=a[i];this.renderAppointment(r,R,A);}if(!R._iAppMinWidth){r.write("<div id=\""+R.getId()+"-DummyApp\" class=\"sapUiCalendarApp sapUiCalendarAppDummy\"></div>");}};C.renderInterval=function(r,R,I,w,a,n,s,N,b,S,c){var d=R.getId()+"-AppsInt"+I;var i=0;var m;var e=R.getShowIntervalHeaders();if(e){for(i=0;i<a.length;i++){var o=a[i];if(o.interval==I){m=o;break;}}}r.write("<div id=\""+d+"\"");r.addClass("sapUiCalendarRowAppsInt");r.addStyle("width",w+"%");for(i=0;i<n.length;i++){if((I+s)%N==n[i]){r.addClass("sapUiCalendarRowAppsNoWork");break;}}if(!e){r.addClass("sapUiCalendarRowAppsIntNoHead");}r.writeClasses();r.writeStyles();r.write(">");if(e){r.write("<div");r.addClass("sapUiCalendarRowAppsIntHead");if(m){if(m.first){r.writeElementData(m.appointment);d=m.appointment.getId();r.addClass("sapUiCalendarRowAppsIntHeadFirst");}else{d=m.appointment.getId()+"-"+I;r.writeAttribute('id',d);}if(m.appointment.getSelected()){r.addClass("sapUiCalendarRowAppsIntHeadSel");}if(m.appointment.getTentative()){r.addClass("sapUiCalendarRowAppsIntHeadTent");}var t=m.appointment.getTooltip_AsString();if(t){r.writeAttributeEscaped('title',t);}var T=m.appointment.getType();if(T&&T!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalendarRowAppsIntHead"+T);}}r.writeClasses();r.write(">");if(m&&m.first){var f=m.appointment.getIcon();if(f){var g=["sapUiCalendarRowAppsIntHeadIcon"];var A={};A["id"]=d+"-Icon";A["title"]=null;r.writeIcon(f,g,A);}var h=m.appointment.getTitle();if(h){r.write("<span");r.writeAttribute("id",d+"-Title");r.addClass("sapUiCalendarRowAppsIntHeadTitle");r.writeClasses();r.write(">");r.writeEscaped(h,true);r.write("</span>");}var k=m.appointment.getText();if(k){r.write("<span");r.writeAttribute("id",d+"-Text");r.addClass("sapUiCalendarRowAppsIntHeadText");r.writeClasses();r.write(">");r.writeEscaped(k,true);r.write("</span>");}}r.write("</div>");}if(R.getShowSubIntervals()){var l=R.getIntervalType();var p=0;switch(l){case sap.ui.unified.CalendarIntervalType.Hour:p=4;break;case sap.ui.unified.CalendarIntervalType.Day:p=24;break;case sap.ui.unified.CalendarIntervalType.Month:var u=R._getStartDate();var v=new U(u);v.setUTCMonth(v.getUTCMonth()+I+1,0);p=v.getUTCDate();v.setUTCDate(1);s=v.getUTCDay();break;default:break;}var x=100/p;for(i=0;i<p;i++){r.write("<div");r.addClass("sapUiCalendarRowAppsSubInt");r.addStyle("width",x+"%");for(var j=0;j<b.length;j++){if((i+S)%c==b[j]){r.addClass("sapUiCalendarRowAppsNoWork");break;}}r.writeStyles();r.writeClasses();r.write(">");r.write("</div>");}}r.write("</div>");};C.renderAppointment=function(r,R,a){var A=a.appointment;var t=A.getTooltip_AsString();var T=A.getType();var s=A.getTitle();var b=A.getText();var i=A.getIcon();var I=A.getId();r.write("<div");r.writeElementData(A);r.addClass("sapUiCalendarApp");if(A.getSelected()){r.addClass("sapUiCalendarAppSel");}if(A.getTentative()){r.addClass("sapUiCalendarAppTent");}if(!b){r.addClass("sapUiCalendarAppTitleOnly");}if(i){r.addClass("sapUiCalendarAppWithIcon");}if(R._bRTL){r.addStyle("right",a.begin+"%");r.addStyle("left",a.end+"%");}else{r.addStyle("left",a.begin+"%");r.addStyle("right",a.end+"%");}r.writeAttribute("data-sap-level",a.level);if(R._sFocusedAppointmentId==I){r.writeAttribute("tabindex","0");}else{r.writeAttribute("tabindex","-1");}if(t){r.writeAttributeEscaped('title',t);}if(T&&T!=sap.ui.unified.CalendarDayType.None){r.addClass("sapUiCalendarApp"+T);}r.writeAccessibilityState(A);r.writeClasses();r.writeStyles();r.write(">");r.write("<div");r.addClass("sapUiCalendarAppCont");r.writeClasses();r.write(">");if(i){var c=["sapUiCalendarAppIcon"];var m={};m["id"]=I+"-Icon";m["title"]=null;r.writeIcon(i,c,m);}if(s){r.write("<span");r.writeAttribute("id",I+"-Title");r.addClass("sapUiCalendarAppTitle");r.writeClasses();r.write(">");r.writeEscaped(s,true);r.write("</span>");}if(b){r.write("<span");r.writeAttribute("id",I+"-Text");r.addClass("sapUiCalendarAppText");r.writeClasses();r.write(">");r.writeEscaped(b,true);r.write("</span>");}r.write("</div>");r.write("</div>");};return C;},true);
